function [ cnnFeatures ] = CnnFeaturesExtractor( x )
    load('convnetEnvZ_8000.mat')
    idx=1;
    [b0,a0]=butter(3,0.01,'high');
    [b1,a1]=butter(3,[0.01 0.1],'bandpass');
    [b2,a2]=butter(3,[0.1 0.2],'bandpass');
    buffer0=buffer(filtfilt(b0,a0,x),1800,1500,'nodelay');
    buffer1=buffer(abs(hilbert(filtfilt(b1,a1,x))),1800,1500,'nodelay');
    buffer2=buffer(abs(hilbert(filtfilt(b2,a2,x))),1800,1500,'nodelay');
    for j=1:size(buffer0,2)
        TensorData(1,:,1,idx)=zscore(buffer0(:,j)');
        TensorData(2,:,1,idx)=zscore(buffer1(:,j)');
        TensorData(3,:,1,idx)=zscore(buffer2(:,j)');
        idx=idx+1;
    end
    y=predict(convnet,TensorData);
    
    y_mean=mean(y);
    y_std=std(y);
    y_max=max(y);
    y_min=min(y);
    
    cnnFeatures=[y_mean,y_std,y_max,y_min];

    
end

