function [ cnnFeatures ] = CnnFeaturesExtractorMultipleBand( x,plot_if_true )
    load('convnetInv.mat')
    idx=1;
    [b0,a0]=butter(3,[1/150 40/150],'bandpass');
    [b1,a1]=butter(3,[1/150 5/150],'bandpass');
    [b2,a2]=butter(3,[5/150 10/150],'bandpass');
    [b3,a3]=butter(3,[10/150 15/150],'bandpass');
    [b4,a4]=butter(3,[15/150 20/150],'bandpass');
    [b5,a5]=butter(3,[20/150 25/150],'bandpass');
    [b6,a6]=butter(3,[25/150 30/150],'bandpass');
    [b7,a7]=butter(3,[30/150 35/150],'bandpass');
    [b8,a8]=butter(3,[35/150 40/150],'bandpass');
    
    buffer0=buffer(filtfilt(b0,a0,x),1800,1500,'nodelay');
    buffer1=buffer(abs(hilbert(filtfilt(b1,a1,x))),1800,1500,'nodelay');
    buffer2=buffer(abs(hilbert(filtfilt(b2,a2,x))),1800,1500,'nodelay');
    buffer3=buffer(abs(hilbert(filtfilt(b3,a3,x))),1800,1500,'nodelay');
    buffer4=buffer(abs(hilbert(filtfilt(b4,a4,x))),1800,1500,'nodelay');
    buffer5=buffer(abs(hilbert(filtfilt(b5,a5,x))),1800,1500,'nodelay');
    buffer6=buffer(abs(hilbert(filtfilt(b6,a6,x))),1800,1500,'nodelay');
    buffer7=buffer(abs(hilbert(filtfilt(b7,a7,x))),1800,1500,'nodelay');
    buffer8=buffer(abs(hilbert(filtfilt(b8,a8,x))),1800,1500,'nodelay');
    for j=1:size(buffer0,2)
        TensorData(1,:,1,idx)=zscore(buffer0(:,j)');
        TensorData(2,:,1,idx)=zscore(buffer1(:,j)');
        TensorData(3,:,1,idx)=zscore(buffer2(:,j)');
        TensorData(4,:,1,idx)=zscore(buffer3(:,j)');
        TensorData(5,:,1,idx)=zscore(buffer4(:,j)');
        TensorData(6,:,1,idx)=zscore(buffer5(:,j)');
        TensorData(7,:,1,idx)=zscore(buffer6(:,j)');
        TensorData(8,:,1,idx)=zscore(buffer7(:,j)');
        TensorData(9,:,1,idx)=zscore(buffer8(:,j)');
        idx=idx+1;
    end
    y=predict(convnet,TensorData);
    
    y_mean=mean(y);
    y_std=std(y);
    y_max=max(y);
    y_min=min(y);
    
%% tady se podivejte jak CNN hodnoti signal
    if plot_if_true==1
        figure
        plot(y)
        legend('N','A','O')
        xlabel('i-cislo v bufferu')
        ylabel('p(i)-pravdepodobnost prislusnosti bufferu(i) do skupin NAO, <0,1>')
        figure
        plot(linspace(0,length(x)/300,length(x)),x)
        title('pro znazorneni signalu')
        close all
    end
    cnnFeatures=[y_mean,y_std,y_max,y_min];
    
end

