function res = buildAvgShape(signalCF,locs, groupCount, leftRad,rightRad,group)
%F.Plesinger, ISI of the CAS, Czech Republic
%part of CinC 2017 challenge code

blockSize = leftRad+rightRad+1;

avgShape=zeros(groupCount,blockSize);



for g=1:groupCount
    groupLocs=locs(group==g);
    
    for s = 1:length(groupLocs)
       center = groupLocs(s);
        
       cL = center-leftRad;
       cR = center+rightRad;
       
       blockDef = cL:cR;
       
       avgShape(g,1:blockSize)=avgShape(g,1:blockSize)+(signalCF(blockDef).')./length(groupLocs);
    end
end

res.avgShape = avgShape;

end

