function res = buildAvgShapeSimple(signalCF,locs, leftRad,rightRad,fs,doQRS300,doPRTW)
%F.Plesinger, ISI of the CAS, Czech Republic
%part of CinC 2017 challenge code

blockSize = leftRad+rightRad+1;

avgShape=zeros(blockSize,1);

addedToSum = 0;
    
dataSize = length(signalCF);

numEX300 = zeros(length(locs),1);

smpls300 = 0.3*fs;



    for s = 1:length(locs)
       center = locs(s);
        
       cL = center-leftRad;
       cR = center+rightRad;
       
       blockDef = cL:cR;
       
       
       if cL<1 || cR>dataSize
           continue;
       end
       
       addition = (signalCF(blockDef));
       
       avgShape(1:blockSize,1)=avgShape(1:blockSize,1)+addition;

       if doQRS300==1
           
           idx300 = center-smpls300:center;
           
           [maxs vals] = findpeaks(signalCF(idx300));
           
           numEX300(s) = length(maxs);
           
       end;
        
       addedToSum=addedToSum+1;
       
    end

res.shp = avgShape./addedToSum;
res.QRS300BefMed = median(numEX300);
res.QRS300BefStd = std(numEX300);
res.time = (1:blockSize)./fs-leftRad/fs;

res.average = mean(res.shp);

if doPRTW

radExcl = fix(0.01*fs);

winLeft = res.shp(1:leftRad-radExcl)-res.average;
signs = abs(diff(sign(winLeft)));
poss=find(signs==2);

res.leftCrossAVGdelta1=0;

if ~isempty(poss)
res.leftCrossAVGsample = poss(length(poss));
res.leftCrossAVGdelta1 = (leftRad-res.leftCrossAVGsample)/fs;
end

res.leftCrossAVGdelta2 = 0;
if length(poss)>1
    res.leftCrossAVGdelta2 = (leftRad-poss(length(poss)-1))/fs;
end

winRight = res.shp(leftRad+radExcl:leftRad+rightRad)-res.average;
signs = abs(diff(sign(winRight)));
res.rightCrossAVGdelta1=0;

poss=find(signs==2);
if ~isempty(poss)
res.rightCrossAVGdelta1 = (poss(1)+radExcl)/fs;
end

res.rightCrossAVGdelta2 = 0;
if length(poss)>1
    res.rightCrossAVGdelta2 = (poss(2)+radExcl)/fs;
end

res.rightCrossAVGdelta3 = 0;
if length(poss)>2
    res.rightCrossAVGdelta3 = (poss(3)+radExcl)/fs;
end

res.rwd = 0;

if res.leftCrossAVGdelta1>0 && res.rightCrossAVGdelta1>0
res.rwd = res.leftCrossAVGdelta1+res.rightCrossAVGdelta1;
end

res.pwd = 0;
if res.leftCrossAVGdelta2~=0
    res.pwd=res.leftCrossAVGdelta2-res.leftCrossAVGdelta1;
end

res.twd = 0;
if res.rightCrossAVGdelta3~=0
    res.twd=res.rightCrossAVGdelta3-res.rightCrossAVGdelta2;
end

end

end

