function classifyResult = challenge(recordName)

[tm,ecg,fs,siginfo]=rdmat(recordName);
%
%ecg = ecg(473:3781); %testy po Ivosve upozorneni
%a00434(9000) 500:8300

totalSamples = length(ecg);

%ecg = -ecg;


if doTable|doPictures
    [pathstr,flnm,ext] = fileparts(recordName);
    refFileName = [pathstr '\REFERENCE.CSV'];
    ftoread = refFileName;
    fid = fopen(ftoread);
    refValues = textscan(fid, '%s %s', 'Delimiter',','); 
    fclose (fid);
    thisIndex = find(strcmp(refValues{1},flnm));
    correctResult = refValues{2}(thisIndex);
    correctResult = strjoin(correctResult);
    
    classifyCode = 4;
    
    if strcmp(correctResult, 'N')
        classifyCode = 1;
    end
    if strcmp(correctResult, 'A')
        classifyCode = 2;
    end
    if strcmp(correctResult, 'O')
        classifyCode = 3;
    end
end

nm = recordName

classifyResult = 'N';
locNN = 0;
mv = 0;


signalSTD = std(ecg);
signalVR = prctile(ecg,95)-prctile(ecg,5);
signalSTDvrRatio = signalSTD/signalVR;
signalLNG = length(ecg)/fs;

signalDiff = diff(ecg); 

signalMAD = median(abs(signalDiff));
signalMADrVR = signalMAD/signalVR;

madWS = 4*fs;
madST = 2*fs;

mad=[];
madVR=[];
blockDiff = zeros(madWS,1);
blockRaw = zeros(madWS,1);

for x=1:madST:length(ecg)-madWS
    blockDiffA = abs(signalDiff(x:x+madWS-1));
    blockRaw = ecg(x:x+madWS-1);
    blockVR = prctile(blockRaw,98)-prctile(blockRaw,2);
    
    id = (x-1)/madST+1;
    mad(id)= median(blockDiffA);
    madVR(id)=mad(id)./blockVR;
end


madMin = min(mad);
madMax = max(mad);
madMed = median(mad);
madSTD = std(mad);

madVRMin= min(madVR);
madVRMax = max(madVR);
madVRMed = median(madVR);
madVRStd = std(madVR);


[pa pb] = findpeaks(ecg);
signalNumPeaks = length(pb);
signalNPlngRatio = signalNumPeaks/signalLNG;

diffPeaks = diff(pb)./fs;
signalPKmed = prctile(diffPeaks,50);
signalPKiqr = prctile(diffPeaks,75)-prctile(diffPeaks,25);
signalPKstd = std(diffPeaks);

ecgFiltered = hfilta(ecg,fs,2,150); %0.8 orig

invalids = zeros(length(ecg),1);

qrsResults = qrsCorrDet(ecg,fs, true, invalids, recordName);

medRR1 = median(qrsResults.rr_1);

recordBPM = getBPM(qrsResults.rr_1);
countRRs = length(qrsResults.rr_1);
stdRRs = std(qrsResults.rr_1);
maxRRs = max(qrsResults.rr_1);
medRRs = median(qrsResults.rr_1);
minRRs = min(qrsResults.rr_1);
vrRRs = maxRRs-minRRs;

longRRratio = maxRRs/medRRs;

%% RRmatrix je k prdu
% %gr = qrsResults.qrsTable(1,:);
% if length(qrsResults.rr_complete)>4
%  rrMatrix(1,:) = qrsResults.qrsTable(2,1:length(qrsResults.rr_complete));
%  rrMatrix(2,:) = qrsResults.rr_complete;
%  rrMatrix(3,:) = qrsResults.KESr2(1:length(qrsResults.rr_complete));
%  rrMatrix(4,:) = qrsResults.KESsMF(1:length(qrsResults.rr_complete));
% end
% % 
%%




rrCompMean = mean(qrsResults.rr_complete);
rrCompVR = max(qrsResults.rr_complete)-min(qrsResults.rr_complete);
rrCompStd = std(qrsResults.rr_complete);


RRsL2 = qrsResults.rr_1;
RRsL2(find(qrsResults.rr_1>2))=[];

RRsL3 = qrsResults.rr_1;
RRsL3(find(qrsResults.rr_1>3))=[];

RRcoverage = sum(RRsL2)/(totalSamples/fs);
RRcoverage3 = sum(RRsL3)/(totalSamples/fs);

RRextraRatio = 1;
RRextraDS = -1;
RRextrasCount = -1;

groupCount = max(qrsResults.group);

groupCountL2 = -1;
groupCountL3 = -1;
groupCountL4 = -1;
groupCountL5 = -1;


if isempty(groupCount)

groupCount=0;

else
groupCountL2 = sum(qrsResults.groupCounts>2);
groupCountL3 = sum(qrsResults.groupCounts>3);
groupCountL4 = sum(qrsResults.groupCounts>4);
groupCountL5 = sum(qrsResults.groupCounts>5);
end


grpCountRatio = groupCount/(length(ecg)*0.001);
qrs1Count = length(qrsResults.group(qrsResults.group==1));

qrs2Count = length(qrsResults.group(qrsResults.group==2));
qrsAllCount = length(qrsResults.group);

ratioQRS1toAll = qrs1Count/qrsAllCount;
ratioQRS2toAll = qrs2Count/qrsAllCount;
ratioQRS2to1 = qrs2Count/qrs1Count;
ratioQRS12toAll = (qrs1Count+qrs2Count)/qrsAllCount;

trustworthSTDmin = qrsResults.rr_tw_std_min;
trustworthSTDmax = qrsResults.rr_tw_std_max;
trustworthSTDmed = qrsResults.rr_tw_std_med;
trustworthSTDstd = qrsResults.rr_tw_std_std;

trustworthBPMmin = qrsResults.rr_tw_bpms_min;
trustworthBPMmed = qrsResults.rr_tw_bpms_med;
trustworthBPMmax = qrsResults.rr_tw_bpms_max;
trustworthBPMstd = qrsResults.rr_tw_bpms_std;

trustworthC0Cmin = qrsResults.rr_tw_c0c_min;
trustworthC0Cmax = qrsResults.rr_tw_c0c_max;
trustworthC0Cavg = qrsResults.rr_tw_c0c_avg;

trustworthC0Amin = qrsResults.rr_tw_c0a_min;
trustworthC0Amax = qrsResults.rr_tw_c0a_max;
trustworthC0Aavg = qrsResults.rr_tw_c0a_avg;

trustworthC0Smin = qrsResults.rr_tw_c0s_min;
trustworthC0Smax = qrsResults.rr_tw_c0s_max;
trustworthC0Smed = qrsResults.rr_tw_c0s_med;

trustworthBPM = getBPM(qrsResults.rr_tw);

trustworthVR = max(qrsResults.rr_tw)-min(qrsResults.rr_tw);

trustworthXDmin = qrsResults.rr_xd_min;
trustworthXDmax = qrsResults.rr_xd_max;
trustworthXDstd = qrsResults.rr_xd_std;
trustworthXDmean = qrsResults.rr_xd_mean;


trustworthXMmin = qrsResults.rr_xm_min;
trustworthXMmax = qrsResults.rr_xm_max;
trustworthXMstd = qrsResults.rr_xm_std;
trustworthXMmean = qrsResults.rr_xm_mean;

trustworthXPmin = qrsResults.rr_xp_min;
trustworthXPmax = qrsResults.rr_xp_max;
trustworthXPstd = qrsResults.rr_xp_std;
trustworthXPmean = qrsResults.rr_xp_mean;


twExPos = [];
twExVals = [];

cnns = CnnFeaturesExtractorMultipleBand(ecg,0);

if ~isempty(qrsResults.rr_tw) && length(qrsResults.rr_tw)>2
[twExVals twExPos] = findpeaks(qrsResults.rr_tw);

trustwrothNExToAll = length(twExPos)/length(qrsResults.rr_tw);

twlocs = qrsResults.qrs_tw;
rad01s = fix(0.1*fs);
twAmps = zeros(length(qrsResults.qrs_tw),1);

for i=1:length(twlocs)
    data = ecg(twlocs(i)-rad01s:twlocs(i)+rad01s);
    twAmps(i) = max(data)-min(data);
end

trustworthAMPstd = std(twAmps);
trustworthAMPvr = max(twAmps)-min(twAmps);
[twAExVals twAExPos] = findpeaks(twAmps);
trustwrothAMPNExToAll = length(twAExPos)/length(qrsResults.rr_tw);

trustworthRatioSTD = trustworthSTDmin/trustworthAMPstd;
trustworthRatioVR = trustworthVR/trustworthAMPvr;
trustworthRatioEX = length(twExPos)/length(twAExPos);


if isnan(trustworthRatioEX)
    trustworthRatioEX = -1;
end

if isinf(trustworthRatioEX)
    trustworthRatioEX = -2;
end



end

diffBPMs = abs(trustworthBPM-recordBPM);

maxKESrisk = max(qrsResults.KESrisk);


extraRRsW0 = qrsResults.rrRatios(qrsResults.rrRatios>0);

extraRRsCNT = length(extraRRsW0);
extraRRsMax = -1;
extraRRsMin = -1;


exToAll = -1;

if countRRs>0
exToAll = extraRRsCNT /countRRs;
end

if extraRRsCNT>0
    extraRRsMax = max(extraRRsW0);
    extraRRsMin = min(extraRRsW0);
end



if length(qrsResults.rr_1)>4
 
featuresPetr = FeaturesExtractor(ecg,qrsResults.qrs_1);
    
[RRpeaksVal RRpeakPos] = findpeaks(qrsResults.rr_1);

RRextraRatio = length(RRpeakPos)/countRRs;
RRextraDS = std(diff(RRpeakPos));

if isnan(RRextraDS)
    RRextraDS = 0;
end

RRav = 0.15;
RRmed = median(qrsResults.rr_1);
RRextras = [qrsResults.rr_1(find(qrsResults.rr_1>(RRmed+RRav))) qrsResults.rr_1(find(qrsResults.rr_1<(RRmed-RRav)))];
RRextrasCount = length(RRextras)/length(qrsResults.rr_1); %opraveno na pomr
end


removedQRScount = 0;%length(qrsResults.removedQRS);
removedQRSratio = 0;%removedQRScount/(countRRs+1);

%corrsMedian =0; %median(qrsResults.corrs);
%corrsStd = 0; %std(qrsResults.corrs);


dRRs = diff(qrsResults.rr_1);

dRRsMEAN=mean(dRRs);
dRRsSTD = std(dRRs);

invalidRatio = sum(invalids)/length(ecg);
stdRRsL2 = std(RRsL2);
dRRsL2 = std(diff(RRsL2));

if isnan(dRRsL2)
  dRRsL2 = 100;
  stdRRsL2 = 100;
end

%ratioG1ToAll = sum(qrsResults.group)/length(qrsResults.qrs);

avrRR = mean(qrsResults.rr_1);

%zmna na pevnou hodnotu

%avrRRsamples = avrRR*fs;

avrRRsamples = 0.8*fs;

avgLeft = fix(0.5*fs);
avgRight =fix(0.5*fs);
avgLength = avgLeft+avgRight+1;


jhRR1 = qrsResults.rr_1(1:length(qrsResults.rr_1)-1);
jhRR2 = qrsResults.rr_1(2:length(qrsResults.rr_1));



expectedQRScount = totalSamples/fs;

qrsCountRatio = length(qrsResults.qrs_1)/expectedQRScount;

dataLF = hobalka(ecg.*(1-invalids),fs,1,8).*(1-invalids);
dataMF = hobalka(ecg.*(1-invalids),fs,5,25).*(1-invalids);

[pksMFvals pksMFpos] = findpeaks(dataMF);


pksMd = median(pksMFvals);
pksP7 = prctile(pksMFvals,75);
pksP9 = prctile(pksMFvals,95);

pksR1 = pksMd/pksP7;
pksR2 = pksMd/pksP9;
pksR3 = pksP7/pksP9;

rrcl = length(qrsResults.rr_complete);
irreg = zeros(rrcl,1);

holeMax=-1;

fbratios=zeros(1,1);

energyMF = zeros(1,1);
rte=zeros(1,1);

if length(qrsResults.qrs_all)>3
 
    for i=1:rrcl
        win=qrsResults.qrs_all(i):qrsResults.qrs_all(i+1);
        energyMF(i)=sum(dataLF(win));
        rte(i)=qrsResults.rr_all(i)/energyMF(i);
    end
    
    
    rrcMean = mean( qrsResults.rr_complete);
    for i=1:rrcl-3
        
        ts = qrsResults.rr_complete(i:i+3);
        
        tsMax = max(ts);
        
        if tsMax>rrcMean
            continue;
        end
        
        fbratios(i)=rrcMean/mean(ts);
        
    end
 
    minRTE=min(rte);
    maxRTE=max(rte);
    medRTE=median(rte);
    vrRTE = maxRTE-minRTE;
    stdRTE=std(rte);
    mmRTE = maxRTE/medRTE;
    
   qrspositions = qrsResults.qrsTable(1,:);
   qrsFreqRats=[];
   qrsLRdist=[];
   
   radw=fix(0.1*fs);
   
   qrsLRdist(1)=qrspositions(2)-qrspositions(1);
   qrsLRdist(length(qrspositions))=qrspositions(length(qrspositions))-qrspositions(length(qrspositions)-1);
   
   for i=1:length(qrspositions)
       
       center = qrspositions(i);
       window = (center-radw):(center+radw);
       qrsFreqRats(i)=sum(dataMF(window))/sum(dataLF(window));
       
       if i>1 && i<length(qrspositions)
           qrsLRdist(i) = (qrspositions(i+1)-qrspositions(i-1))/2;
       end
   end
   
   qrsLRdist = qrsLRdist./fs;
   
   meanLRdist = mean(qrsLRdist);
   stdLRdist = std(qrsLRdist);
   meanFreq = mean(qrsFreqRats);
   stdFreq = std(qrsFreqRats);

   stdLRDm = stdLRdist-stdFreq;
   stdLRSm = stdLRdist+stdFreq;
   
   centersLR=0.3:0.05:1.3;
   hqrs = hist(qrsLRdist,centersLR);
   hqrsLR = hqrs./max(hqrs);
   
   hqrsLRsum = sum(hqrsLR);
   
   
  
   
   centersF=0:0.15:3;
   hqrs = hist(qrsFreqRats,centersF);
   hqrsF = hqrs./max(hqrs);
   hqrsFsum = sum(hqrsF);
   
   stdLRFratio = stdLRdist/stdFreq;
   
   histRRsC = hist(qrsResults.rr_complete, centersF);
   histRRsC = histRRsC./max(histRRsC);
   
   [m loc] = findpeaks(histRRsC,'MINPEAKDISTANC',2,'NPEAKS',2,'SORTSTR','descend');
   
   histRRh2=0;
   histRRelevH2=0;
   histRRh2w=0;
   
   if length(loc)==2 && loc(2)>loc(1)
       
       win=loc(1):loc(2);
       
       minBetween = min(histRRsC(win));
       
       histRRh2=m(2);
       
       histRRelevH2=histRRh2-minBetween;
       
       histRRh2w = m(2)*(1-minBetween);
       
   end
   
   
   
   for i=1:length(qrsResults.rr_complete)-1
       rrI = qrsResults.rr_complete(i);
       rrN = qrsResults.rr_complete(i+1);
       
       if rrI>rrCompMean || rrN<rrCompMean || rrN>2
           continue;
       end
       pa = qrsResults.qrs_complete(i);
       pb = qrsResults.qrs_complete(i+1);
       pc = qrsResults.qrs_complete(i+2);
       
       energyI = sum(dataMF(pa:pb));
       energyN = sum(dataMF(pb:pc));
       
       lnRatio = (pc-pb)/(pb-pa);
       
       
       
       change = rrCompMean/((pb-pa)/fs);
       
         
       
       if change<1.2
           continue;
       end
       
       if energyN>energyI*1.3
           continue;
       end
      
       dev = sqrt((rrI-rrCompMean)^2+(rrN-rrCompMean)^2);
       irreg(i)=dev;
       
   end
   
end
   
irregMax = max(irreg);
irregHZ = irreg(irreg~=0);
irregCnt = length(irregHZ);
irregMean = mean(irregHZ);
irregRatio = irregCnt/max([length(irreg) 1]);

if irregMax == 0
    irregMean = 0;
    irregRatio = 0;
end

fbMax=max(fbratios);


rr1cnt = length(qrsResults.rr_1);


holeMeasure = -1;

if rr1cnt>4
    for i=1:rr1cnt-6
        
        
        trio = qrsResults.rr_1(i:i+2);
        trioSTD = std(trio);
        trioAVG = mean(trio);
        
        if trioSTD>stdRRs
            continue
        end
        
        rr5 = qrsResults.rr_1(5);
        rr6 = qrsResults.rr_1(6);
        
        trioQRS = qrsResults.qrs_1(i+4);
        
        delta5 = abs(1-trioAVG/rr5);
        delta6 = abs(1- trioAVG/rr6);
        
        if delta5>0.2 && delta6>0.2
            continue
        end
        
        distantQRS = qrsResults.qrs_1(i+5);

        if delta5>0.2
            distantQRS = qrsResults.qrs_1(i+6);
        end
        
        dst = distantQRS-trioQRS;
        
        rest = mod(dst./fs,trioAVG) ;
        
        
        holeMeasure(i) = -abs(rest-0.5)+0.5;
        
        
        
    end
end

holeMax = max(holeMeasure);


if ~isnan(avrRR) && avrRR<3 && length(jhRR1)>1 && length(jhRR2)>1

    


% dataIF = hobalka(ecg.*(1-invalids),fs,25,45).*(1-invalids);
% dataHF = hobalka(ecg.*(1-invalids),fs,45,65).*(1-invalids);




twMFamps = dataMF(qrsResults.qrs_tw);
trustworthMFstd = std(twMFamps);



pWavePre = medRR1/5; %%orig 4

if pWavePre>0.300
    pWavePre =0.3; 
end

pWavePreSamples = fix(pWavePre*fs);

avgRAW = buildAvgShapeSimple(ecg,qrsResults.qrs_1,avgLeft,avgRight,fs,0,1);

avgRAWdl1 = avgRAW.leftCrossAVGdelta1;
avgRAWdl2 = avgRAW.leftCrossAVGdelta2;
avgRAWdr2 = avgRAW.rightCrossAVGdelta2;
avgRAWpwd = avgRAW.pwd;
avgRAWrwd = avgRAW.rwd;
avgRAWtwd = avgRAW.twd;

avgRAW2dl1 = avgRAW.leftCrossAVGdelta1;
avgRAW2dl2 = avgRAW.leftCrossAVGdelta2;
avgRAW2dr2 = avgRAW.rightCrossAVGdelta2;
avgRAW2pwd = avgRAW.pwd;
avgRAW2rwd = avgRAW.rwd;
avgRAW2twd = avgRAW.twd;

avgRAW_2 = [];
if length(qrsResults.qrs_2)>0
avgRAW_2 = buildAvgShapeSimple(ecg,qrsResults.qrs_2,avgLeft,avgRight,fs,0,1);

avgRAW2dl1 = avgRAW_2.leftCrossAVGdelta1;
avgRAW2dl2 = avgRAW_2.leftCrossAVGdelta2;
avgRAW2dr2 = avgRAW_2.rightCrossAVGdelta2;
avgRAW2pwd = avgRAW_2.pwd;
avgRAW2rwd = avgRAW_2.rwd;
avgRAW2twd = avgRAW_2.twd;
end

avgLF = buildAvgShapeSimple(dataLF,qrsResults.qrs_1,avgLeft,avgRight,fs,0,0);
avgMF = buildAvgShapeSimple(dataMF,qrsResults.qrs_1,avgLeft,avgRight,fs,0,0);

% avgIF = buildAvgShapeSimple(dataIF,qrsResults.qrs_1,avgLeft,avgRight,fs,1);
% avgHF = buildAvgShapeSimple(dataHF,qrsResults.qrs_1,avgLeft,avgRight,fs,1);

avgLF2 = buildAvgShapeSimple(dataLF,qrsResults.qrs_2,avgLeft,avgRight,fs,0,0);
avgMF2 = buildAvgShapeSimple(dataMF,qrsResults.qrs_2,avgLeft,avgRight,fs,0,0);

elevationRAW = getElevation(avgRAW,fs);

pWaveWin = elevationRAW.leftWin(end)-pWavePreSamples:elevationRAW.leftWin(end);
pWaveWin = pWaveWin(pWaveWin>0);
pWaveData = avgRAW.shp(pWaveWin);

pWaveAVG_VR = max(pWaveData)-min(pWaveData);
pWaveAVG_STD = std(pWaveData);
pWaveAVG_Mean = mean(pWaveData);


avgRAW_VR = max(avgRAW.shp)-min(avgRAW.shp);
pWaveAVG_STD_NORM = pWaveAVG_STD/avgRAW_VR;

stds = zeros(pWavePreSamples,1);

offs = -avgLeft+elevationRAW.leftWin(end);

for s=1:pWavePreSamples
    
    xLocs = qrsResults.qrs_1-s-offs;
    stds(s) = std(ecg(xLocs(xLocs>1)));
end

pWaveSTD_med = median(stds);

pW1 = pWaveAVG_VR/pWaveSTD_med;
pW2 = pWaveAVG_STD/pWaveSTD_med;
pW3 = pWaveAVG_Mean/pWaveSTD_med;

qrs1ratioLFMF = avgLF.shp(avgLeft)/avgMF.shp(avgLeft);

qrs2ratioLFMF = 0;
qrs12ratioLFMF = 0;

if qrs2Count>0
qrs2ratioLFMF = avgLF2.shp(avgLeft)/avgMF2.shp(avgLeft);
qrs12ratioLFMF = qrs1ratioLFMF/qrs2ratioLFMF;
end

if isnan(qrs2ratioLFMF) || isnan(qrs12ratioLFMF)
  qrs2ratioLFMF = -1;  
  qrs12ratioLFMF = -1;
end


% MF300MsCountMedian = avgMF.QRS300BefMed;
% IF300MsCountMedian = avgIF.QRS300BefMed;
% MF300MsCountSTD = avgMF.QRS300BefStd;
% IF300MsCountSTD = avgIF.QRS300BefStd;
    
crc = corrcoef(jhRR1,jhRR2);
    
jhCorrRR = crc(1,2); 
    
startA = fix(avgLength/2-avrRRsamples/4);
endA = fix(avgLength/2-avrRRsamples/10);
startB = fix(avgLength/2-avrRRsamples/10);
endB = fix(avgLength/2+avrRRsamples/10);
startC =fix( avgLength/2+avrRRsamples/10);
endC = fix(avgLength/2+avrRRsamples/4);

% z medinovch tvar

rawNumExA = length(findpeaks(avgRAW.shp(startA:endA)))+length(findpeaks(-avgRAW.shp(startA:endA)));
rawNumExB = length(findpeaks(avgRAW.shp(startB:endB)))+length(findpeaks(-avgRAW.shp(startB:endB)));
rawNumExC = length(findpeaks(avgRAW.shp(startC:endC)))+length(findpeaks(-avgRAW.shp(startC:endC)));

RawMedAMean = mean(avgRAW.shp(startA:endA));
RawMedAstd = std(avgRAW.shp(startA:endA));
RawMedAskw = skewness(avgRAW.shp(startA:endA));
RawMedAkrt = kurtosis(avgRAW.shp(startA:endA));
RawMedBMean = mean(avgRAW.shp(startB:endB));
RawMedBstd = std(avgRAW.shp(startB:endB));
RawMedBskw = skewness(avgRAW.shp(startB:endB));
RawMedBkrt = kurtosis(avgRAW.shp(startB:endB));
RawMedCMean = mean(avgRAW.shp(startC:endC));
RawMedCstd = std(avgRAW.shp(startC:endC));
RawMedCskw = skewness(avgRAW.shp(startC:endC));
RawMedCkrt = kurtosis(avgRAW.shp(startC:endC));

RawMedBCstd = std(avgRAW.shp(startB:endC));

ratioRawMedStdAB = RawMedAstd/RawMedBstd;
ratioRawMedStdBC = RawMedBstd/RawMedCstd;
ratioRawMedStdAC = RawMedAstd/RawMedCstd;
ratioRawMedStdABC = RawMedAstd/(RawMedBstd+RawMedCstd);
ratioRawMedStdABC2 = RawMedAstd/RawMedBCstd;

ratioRawMedAC = RawMedAMean/RawMedCMean;
ratioRawMedBC = RawMedBMean/RawMedCMean;

LFMedAMean = mean(avgLF.shp(startA:endA));
LFMedAstd = std(avgLF.shp(startA:endA));
LFMedBMean = mean(avgLF.shp(startB:endB));
LFMedBstd = std(avgLF.shp(startB:endB));
LFMedCMean = mean(avgLF.shp(startC:endC));
LFMedCstd = std(avgLF.shp(startC:endC));

MFMedAMean = mean(avgMF.shp(startA:endA));
MFMedAstd = std(avgMF.shp(startA:endA));
MFMedBMean = mean(avgMF.shp(startB:endB));
MFMedBstd = std(avgMF.shp(startB:endB));
MFMedCMean = mean(avgMF.shp(startC:endC));
MFMedCstd = std(avgMF.shp(startC:endC));




end

classifyResult = '~';

numShapes = 30;
cts = zeros(numShapes,1);
strongestCorr = 0;
strongestCorrV = 0;

cts_2 = zeros(numShapes,1);
strongestCorr_2 = 0;
strongestCorrV_2 = 0;

diffMaxCorrs = 0;

longestBlockOverBPM = -1;
longestBlockUnderBPM = -1;
longestBlockAny = -1;

if exist('rawNumExA','var') && exist('featuresPetr','var')

    co=0;
    cu=0;
    c=0;
    
%avrRR = mean(qrsResults.rr_1);
for ri=2:length(qrsResults.rr_1);
    ar = qrsResults.rr_1(ri)-avrRR;
    a0 = qrsResults.rr_1(ri-1)-avrRR;

    if sign(ar)==sign(a0)
            c=c+1;
    else
        longestBlockOverBPM = max([longestBlockOverBPM, c]);
        c=0;
    end
end

  longestBlockOverBPM = max([longestBlockOverBPM, c]);

    
load('medshapes.mat');
crad = 30;
avgRAW61 = avgRAW.shp(avgLeft-crad:avgLeft+crad);
for i=1:numShapes
       crc = corrcoef(avgRAW61,medShape(i,:));
       cts(i)= abs(crc(1,2)); 
end
[strongestCorrV strongestCorr] = max(cts);    




if ~isempty(avgRAW_2)
numNan2 = sum(isnan(avgRAW_2.shp));
if numNan2 == 0
load('medshapes_2.mat');
crad = 30;
avgRAW61_2 = avgRAW_2.shp(avgLeft-crad:avgLeft+crad);
for i=1:numShapes
       crc = corrcoef(avgRAW61_2,medShape(i,:));
       cts_2(i)= abs(crc(1,2)); 
end
[strongestCorrV_2 strongestCorr_2] = max(cts_2);    
end
end    
  
diffMaxCorrs = strongestCorrV-strongestCorrV_2;

avgNsubMaxO = cnns(1)- cnns(9);
avgNsubMaxA = cnns(1) - cnns(8);
[mvcnn maxCodeNAO]= max(cnns(7:9));
[mvcnn maxCodeAvgNMaxAO]= max([cnns(1) cnns(8:9)]);
sumNprev = avgNsubMaxO*avgNsubMaxA;


%inputParams = [pksMd,pksP7,pksP9,pksR1,pksR2,pksR3,signalMAD,signalMADrVR,madMin,madMax,madMed,madSTD,madVRMin,madVRMax,madVRMed,madVRStd,signalSTD,signalVR,signalSTDvrRatio,signalLNG,signalNumPeaks,signalNPlngRatio,signalPKmed,signalPKiqr,signalPKstd,recordBPM,countRRs,stdRRs,RRcoverage,RRcoverage3,longestBlockOverBPM,rrCompMean,rrCompVR,rrCompStd,irregMax,irregCnt,irregMean,irregRatio,fbMax,holeMax,minRTE,maxRTE,medRTE,vrRTE,stdRTE,mmRTE,avgRAWdl1,avgRAWdl2,avgRAWdr2,avgRAWpwd,avgRAWrwd,avgRAWtwd,avgRAW2dl1,avgRAW2dl2,avgRAW2dr2,avgRAW2pwd,avgRAW2rwd,avgRAW2twd,dRRsMEAN,dRRsSTD,qrsCountRatio,histRRh2,histRRelevH2,histRRh2w,RRextraDS,RRextraRatio,RRextrasCount,extraRRsCNT,extraRRsMin,extraRRsMax,exToAll,maxRRs,medRRs,minRRs,vrRRs,longRRratio,elevationRAW.elevationAbs,elevationRAW.elevationRel,elevationRAW.timeDist,invalidRatio,stdRRsL2,dRRsL2,maxKESrisk,qrs1ratioLFMF,qrs2ratioLFMF,qrs12ratioLFMF,groupCount,qrs1Count,qrs2Count,qrsAllCount,grpCountRatio,groupCountL2,groupCountL3,groupCountL4,groupCountL5,ratioQRS1toAll,ratioQRS2toAll,ratioQRS2to1,ratioQRS12toAll,trustworthSTDmin,trustworthSTDmax,trustworthSTDmed,trustworthSTDstd,trustworthBPM,trustworthMFstd,diffBPMs,trustworthVR,trustwrothNExToAll,trustworthAMPstd,trustworthAMPvr,trustwrothAMPNExToAll,trustworthRatioSTD,trustworthRatioVR,trustworthRatioEX,trustworthBPMmin,trustworthBPMmed,trustworthBPMmax,trustworthBPMstd,trustworthC0Cmin,trustworthC0Cmax,trustworthC0Cavg,trustworthC0Smin,trustworthC0Smax,trustworthC0Smed,trustworthXDmin,trustworthXDmax,trustworthXDstd,trustworthXDmean,trustworthXMmin,trustworthXMmax,trustworthXMstd,trustworthXMmean,trustworthXPmin,trustworthXPmax,trustworthXPstd,trustworthXPmean,meanLRdist,stdLRdist,meanFreq,stdFreq,stdLRDm,stdLRSm,hqrsLRsum,hqrsFsum,stdLRFratio,RawMedAMean,RawMedAstd,RawMedBMean,RawMedBstd,RawMedCMean,RawMedCstd,RawMedAskw,RawMedAkrt,RawMedBskw,RawMedBkrt,RawMedCskw,RawMedCkrt,ratioRawMedStdAB,ratioRawMedStdBC,ratioRawMedStdAC,ratioRawMedStdABC,ratioRawMedStdABC2,ratioRawMedAC,ratioRawMedBC,LFMedAMean,LFMedAstd,LFMedBMean,LFMedBstd,LFMedCMean,LFMedCstd,MFMedAMean,MFMedAstd,MFMedBMean,MFMedBstd,MFMedCMean,MFMedCstd,rawNumExA,rawNumExB,rawNumExC,jhCorrRR,featuresPetr.RRp10,featuresPetr.RRskew,featuresPetr.CQRSmean,featuresPetr.eQRSmax,featuresPetr.PwaveP2P,featuresPetr.PwaveRpp,pWaveAVG_VR,pWaveAVG_STD,pWaveAVG_Mean,pWaveSTD_med,pW1,pW2,pW3,avgRAW_VR,pWaveAVG_STD_NORM,cts(1),cts(2),cts(3),cts(4),cts(5),cts(6),cts(7),cts(8),cts(9),cts(10),cts(11),cts(12),cts(13),cts(14),cts(15),cts(16),cts(17),cts(18),cts(19),cts(20),cts(21),cts(22),cts(23),cts(24),cts(25),cts(26),cts(27),cts(28),cts(29),cts(30),strongestCorrV,strongestCorr,cts_2(1),cts_2(2),cts_2(3),cts_2(4),cts_2(5),cts_2(6),cts_2(7),cts_2(8),cts_2(9),cts_2(10),cts_2(11),cts_2(12),cts_2(13),cts_2(14),cts_2(15),cts_2(16),cts_2(17),cts_2(18),cts_2(19),cts_2(20),cts_2(21),cts_2(22),cts_2(23),cts_2(24),cts_2(25),cts_2(26),cts_2(27),cts_2(28),cts_2(29),cts_2(30),strongestCorrV_2,strongestCorr_2,diffMaxCorrs,cnns(1),cnns(2),cnns(3),cnns(4),cnns(5),cnns(6),cnns(7),cnns(8),cnns(9),cnns(10),cnns(11),cnns(12),avgNsubMaxO,avgNsubMaxA,maxCodeNAO,maxCodeAvgNMaxAO,sumNprev];
%outputNN = myNeuralNetworkFunctionMultipleband_ALLparamsInv(inputParams');


locNN=4;


if ((grpCountRatio>=1.000001 && grpCountRatio<=300) && (diffBPMs>=3.00001 && diffBPMs<=500) && (stdLRdist>=0.2 && stdLRdist<=100)) || (RRcoverage3>=0 && RRcoverage3<=0.4) || ((RRcoverage3<=0.7) && (countRRs<=10))
    
    locNN = 4;
    
else
    if (trustworthBPMmed>=51 && trustworthBPMmed<=99) && (cnns(9)<=0.35) && (cnns(7)>=0.82)
        
        locNN=1;
    else
        
 inputParams = [pksMd,pksP7,pksP9,pksR1,pksR2,pksR3,signalMAD,signalMADrVR,madMin,madMax,madMed,madSTD,madVRMin,madVRMax,madVRMed,madVRStd,signalSTD,signalVR,signalSTDvrRatio,signalLNG,signalNumPeaks,signalNPlngRatio,signalPKmed,signalPKiqr,signalPKstd,recordBPM,countRRs,stdRRs,RRcoverage,RRcoverage3,longestBlockOverBPM,rrCompMean,rrCompVR,rrCompStd,irregMax,irregCnt,irregMean,irregRatio,fbMax,holeMax,minRTE,maxRTE,medRTE,vrRTE,stdRTE,mmRTE,avgRAWdl1,avgRAWdl2,avgRAWdr2,avgRAWpwd,avgRAWrwd,avgRAWtwd,avgRAW2dl1,avgRAW2dl2,avgRAW2dr2,avgRAW2pwd,avgRAW2rwd,avgRAW2twd,dRRsMEAN,dRRsSTD,qrsCountRatio,histRRh2,histRRelevH2,histRRh2w,RRextraDS,RRextraRatio,RRextrasCount,extraRRsCNT,extraRRsMin,extraRRsMax,exToAll,maxRRs,medRRs,minRRs,vrRRs,longRRratio,elevationRAW.elevationAbs,elevationRAW.elevationRel,elevationRAW.timeDist,invalidRatio,stdRRsL2,dRRsL2,maxKESrisk,qrs1ratioLFMF,qrs2ratioLFMF,qrs12ratioLFMF,groupCount,qrs1Count,qrs2Count,qrsAllCount,grpCountRatio,groupCountL2,groupCountL3,groupCountL4,groupCountL5,ratioQRS1toAll,ratioQRS2toAll,ratioQRS2to1,ratioQRS12toAll,trustworthSTDmin,trustworthSTDmax,trustworthSTDmed,trustworthSTDstd,trustworthBPM,trustworthMFstd,diffBPMs,trustworthVR,trustwrothNExToAll,trustworthAMPstd,trustworthAMPvr,trustwrothAMPNExToAll,trustworthRatioSTD,trustworthRatioVR,trustworthRatioEX,trustworthBPMmin,trustworthBPMmed,trustworthBPMmax,trustworthBPMstd,trustworthC0Cmin,trustworthC0Cmax,trustworthC0Cavg,trustworthC0Smin,trustworthC0Smax,trustworthC0Smed,trustworthXDmin,trustworthXDmax,trustworthXDstd,trustworthXDmean,trustworthXMmin,trustworthXMmax,trustworthXMstd,trustworthXMmean,trustworthXPmin,trustworthXPmax,trustworthXPstd,trustworthXPmean,meanLRdist,stdLRdist,meanFreq,stdFreq,stdLRDm,stdLRSm,hqrsLRsum,hqrsFsum,stdLRFratio,RawMedAMean,RawMedAstd,RawMedBMean,RawMedBstd,RawMedCMean,RawMedCstd,RawMedAskw,RawMedAkrt,RawMedBskw,RawMedBkrt,RawMedCskw,RawMedCkrt,ratioRawMedStdAB,ratioRawMedStdBC,ratioRawMedStdAC,ratioRawMedStdABC,ratioRawMedStdABC2,ratioRawMedAC,ratioRawMedBC,LFMedAMean,LFMedAstd,LFMedBMean,LFMedBstd,LFMedCMean,LFMedCstd,MFMedAMean,MFMedAstd,MFMedBMean,MFMedBstd,MFMedCMean,MFMedCstd,rawNumExA,rawNumExB,rawNumExC,jhCorrRR,featuresPetr.RRp10,featuresPetr.RRskew,featuresPetr.CQRSmean,featuresPetr.eQRSmax,featuresPetr.PwaveP2P,featuresPetr.PwaveRpp,pWaveAVG_VR,pWaveAVG_STD,pWaveAVG_Mean,pWaveSTD_med,pW1,pW2,pW3,avgRAW_VR,pWaveAVG_STD_NORM,cts(1),cts(2),cts(3),cts(4),cts(5),cts(6),cts(7),cts(8),cts(9),cts(10),cts(11),cts(12),cts(13),cts(14),cts(15),cts(16),cts(17),cts(18),cts(19),cts(20),cts(21),cts(22),cts(23),cts(24),cts(25),cts(26),cts(27),cts(28),cts(29),cts(30),strongestCorrV,strongestCorr,cts_2(1),cts_2(2),cts_2(3),cts_2(4),cts_2(5),cts_2(6),cts_2(7),cts_2(8),cts_2(9),cts_2(10),cts_2(11),cts_2(12),cts_2(13),cts_2(14),cts_2(15),cts_2(16),cts_2(17),cts_2(18),cts_2(19),cts_2(20),cts_2(21),cts_2(22),cts_2(23),cts_2(24),cts_2(25),cts_2(26),cts_2(27),cts_2(28),cts_2(29),cts_2(30),strongestCorrV_2,strongestCorr_2,diffMaxCorrs,cnns(1),cnns(2),cnns(3),cnns(4),cnns(5),cnns(6),cnns(7),cnns(8),cnns(9),cnns(10),cnns(11),cnns(12),avgNsubMaxO,avgNsubMaxA,maxCodeNAO,maxCodeAvgNMaxAO,sumNprev];
 outputNN = myNeuralNetworkFunctionMultipleband_ALLparamsInv(inputParams');


        [lcv locNN] = max(outputNN);
    
        load ens_inv;
        inputE3 = [pksMd pksP7 pksP9 pksR3 countRRs RRcoverage3 rrCompVR irregMean holeMax maxRTE mmRTE avgRAWdr2 avgRAWpwd avgRAWtwd avgRAW2rwd avgRAW2twd dRRsMEAN RRextraRatio RRextrasCount extraRRsCNT extraRRsMax maxRRs medRRs minRRs elevationRAW.elevationAbs maxKESrisk qrs1Count qrsAllCount groupCountL4 trustworthSTDmin trustworthSTDmed trustworthBPM trustwrothNExToAll trustworthAMPvr trustworthRatioVR meanFreq stdLRDm stdLRSm stdLRFratio RawMedAkrt ratioRawMedStdAB ratioRawMedStdBC LFMedAstd LFMedBMean LFMedBstd MFMedBMean MFMedCstd featuresPetr.RRp10 featuresPetr.RRskew featuresPetr.eQRSmax pWaveAVG_STD pWaveAVG_STD_NORM cts(2) cts(4) cts(6) cts(10) cts(17) cts(18) cts(19) cts(20) cts(24) cts(30) cts_2(3) cts_2(5) cts_2(8) cts_2(9) cts_2(13) cts_2(14) cts_2(30) signalMAD signalMADrVR madMin madMax madMed madSTD madVRMin madVRMax madVRMed madVRStd signalSTD signalVR signalSTDvrRatio signalLNG signalNumPeaks signalNPlngRatio signalPKmed signalPKiqr signalPKstd longestBlockOverBPM trustworthBPMmin trustworthBPMmed trustworthBPMmax trustworthBPMstd trustworthC0Cmin trustworthC0Cmax trustworthC0Cavg trustworthC0Smin trustworthC0Smax trustworthC0Smed trustworthXDmin trustworthXDmax trustworthXDstd trustworthXDmean trustworthXMmin trustworthXMmax trustworthXMstd trustworthXMmean trustworthXPmin trustworthXPmax trustworthXPstd trustworthXPmean ratioRawMedBC avgNsubMaxO avgNsubMaxA maxCodeNAO maxCodeAvgNMaxAO sumNprev outputNN(1) outputNN(2) outputNN(3)];
        pred = ens.predict(inputE3);
  
    %    load ens22;
    %    inputParI2 = [pksMd pksP7 pksP9 pksR3 countRRs RRcoverage3 rrCompVR irregMean holeMax maxRTE mmRTE avgRAWdr2 avgRAWpwd avgRAWtwd avgRAW2rwd avgRAW2twd dRRsMEAN RRextraRatio RRextrasCount extraRRsCNT extraRRsMax maxRRs medRRs minRRs elevationRAW.elevationAbs maxKESrisk qrs1Count qrsAllCount groupCountL4 trustworthSTDmin trustworthSTDmed trustworthBPM trustwrothNExToAll trustworthAMPvr trustworthRatioVR meanFreq stdLRDm stdLRSm stdLRFratio RawMedAkrt ratioRawMedStdAB ratioRawMedStdBC LFMedAstd LFMedBMean LFMedBstd MFMedBMean MFMedCstd featuresPetr.RRp10 featuresPetr.RRskew featuresPetr.eQRSmax pWaveAVG_STD pWaveAVG_STD_NORM cts(2) cts(4) cts(6) cts(10) cts(17) cts(18) cts(19) cts(20) cts(24) cts(30) cts_2(3) cts_2(5) cts_2(8) cts_2(9) cts_2(13) cts_2(14) cts_2(30) signalMAD signalMADrVR madMin madMax madMed madSTD madVRMin madVRMax madVRMed madVRStd signalSTD signalVR signalSTDvrRatio signalLNG signalNumPeaks signalNPlngRatio signalPKmed signalPKiqr signalPKstd longestBlockOverBPM trustworthBPMmin trustworthBPMmed trustworthBPMmax trustworthBPMstd trustworthC0Cmin trustworthC0Cmax trustworthC0Cavg trustworthC0Smin trustworthC0Smax trustworthC0Smed ratioRawMedBC avgNsubMaxO avgNsubMaxA maxCodeNAO maxCodeAvgNMaxAO sumNprev cnns(1) cnns(2) cnns(3) cnns(4) cnns(5) cnns(6) cnns(7) cnns(8) cnns(9) cnns(10) cnns(11) cnns(12)]; 
    %    pred = ens.predict(inputParI2);
     
    
        
        if strcmp(pred,'N')
            locNN=1;
        end
        
         if strcmp(pred,'A')
            locNN=2;
        end
        
         if strcmp(pred,'O')
            locNN=3;
        end
        
        
    %    [mv locNN] = max(outputNN);
        
        if locNN==1
            if recordBPM>99.5 %tachykardie
                locNN = 3;
            end
        end
        
        
   
    end
    
    
    classifyResult = '~';
    
    switch(locNN)
        case 1
            classifyResult = 'N';
        case 2
            classifyResult = 'A';
        case 3
            classifyResult = 'O';
        case 4
            classifyResult = '~';
    end
    
    
end

if (doPictures)
    
%  R referenceResult = Ref(2.N);
   
  nm = [recordName ':' correctResult '; classifyResult = ' classifyResult];

  
   FigHandle = figure('Name',recordName);
  set(FigHandle, 'Position', [100 100 1600 800]);
  
  color = [0.7 0.7 0.7];
  
  bcol = [1 1 1];
  
  if strcmp(correctResult,'N')
       color = [0.2 0.8 0.0];
  end

  if strcmp(correctResult,'A')
       color = [1 0.5 0.0];
  end
  
  if strcmp(correctResult,'O')
       color = [1 0 0.5];
  end
  
    annotation('textbox',[0 0.95 1 0.05],'String',nm,'BackgroundColor',color);
  
   handle = subplot(3,1,1);
     
  
   set(handle, 'color',bcol);
    


   hold on;
   
   area(tm,invalids.*2,'FaceColor',[0.7 0.7 0.7]);
  
   plot(tm,ecg,'Color',[0.8 0.8 0.8]);
   plot(tm,ecgFiltered,'k');
   plot(qrsResults.qrs_all./fs,ecgFiltered(qrsResults.qrs_all),'bo','MarkerFaceColor',[0.0 0.5 1.0]);

   
   
    str = ['BPM_1 =' num2str(recordBPM)];
    str=[str,char(10),'RRs_1 =', num2str(countRRs)];
    str=[str,char(10),'std(RRs_1) =',num2str(stdRRs)];
    str=[str,char(10),'RR_1 cover =',num2str(RRcoverage)];
   
    str=[str,char(10),char(10),'mean(dRR_1) =',num2str(dRRsMEAN)];
    str=[str,char(10),'std(dRR_1) =',num2str(dRRsSTD)];
    


    str=[str,char(10),char(10),'TW BPM =',num2str(trustworthBPM)];
    str=[str,char(10),'TW std_m_i_n =',num2str(trustworthSTDmin)];
    str=[str,char(10),'TW std_m_a_x =',num2str(trustworthSTDmax)];
    str=[str,char(10),'TW std_m_e_d =',num2str(trustworthSTDmed)];
    str=[str,char(10),'TW std_s_t_d =',num2str(trustworthSTDstd)];
   
%     str=[str,char(10),char(10),'pW1 =',num2str(pW1)];
%     str=[str,char(10),'pW2 =',num2str(pW2)];
%     str=[str,char(10),'pW3 =',num2str(pW3)];
    
    
    annotation('textbox',[0.92 0.50 0.07 0.40],'String', str,'BackgroundColor','w');
   
   
   handle = subplot(3,1,2);
   set(handle, 'color',bcol);
     
   hold on;
   if exist('avgRAW','var')
    plot(avgRAW.time,avgRAW.shp.*1.00,'m');
    plot(avgRAW.time,avgLF.shp.*1,'k');
    plot(avgRAW.time,avgMF.shp.*4,'r');
%    plot(avgRAW.time,avgIF.shp.*0.5,'b')
%    plot(avgRAW.time,avgHF.shp.*400,'g');

    timesLeft = elevationRAW.leftWin;
    timesRight = elevationRAW.rightWin;
    plot(avgRAW.time(timesLeft),avgRAW.shp(timesLeft),'k-','linewidth',2);
    plot(avgRAW.time(timesRight),avgRAW.shp(timesRight),'k-','linewidth',2);
    
    avrRR = mean(qrsResults.rr_1);
    y = max(avgMF.shp.*6);
    
    va = -avrRR/4;
    vb = -avrRR/10;
    vc = avrRR/10;
    vd = avrRR/4;
    
    line([-avrRR/4 -avrRR/4],[0 y],'Color',[0 0 0],'Linewidth',2);
    line([avrRR/4 avrRR/4],[0 y],'Color',[0 0 0],'Linewidth',2);
    text(-avrRR/4,y,[' A start ' num2str(va)]);
    text(avrRR/4,y,[' C end ' num2str(vd)]);
    line([-avrRR/10 -avrRR/10],[0 y],'Color',[0 0 0],'Linewidth',2);
    line([avrRR/10 avrRR/10],[0 y],'Color',[0 0 0],'Linewidth',2);
    text(-avrRR/10,y,[' B start ' num2str(vb)]);
    text(avrRR/10,y,[' C start ' num2str(vc)]);
    
    
  legend('0.25 x RAW','0.5 x avgLShape 1-8 Hz','4 x avgMShape 5-25 Hz');
   end  
  
    handle = subplot(3,3,7);
   set(handle, 'color',bcol);
     
   hold on;

  
   
   plot(qrsLRdist,qrsFreqRats,'bo');
   axis([0 2 0 3]);
   
   line([meanLRdist meanLRdist],[meanFreq-stdFreq meanFreq+stdFreq],'LineWidth',2,'Color',[0 0 0]);
   line([meanLRdist-stdLRdist meanLRdist+stdLRdist],[meanFreq meanFreq],'LineWidth',2,'Color',[0 0 0]);
   
   handle = subplot(3,3,8);
   set(handle, 'color',bcol);
   hold on;
   
   
   
   bar(centersLR,hqrsLR);
   axis([0.3 1.3 0 1]);
   

 handle = subplot(3,3,9);
   set(handle, 'color',bcol);
   hold on;
   
   
   
   bar(centersF,hqrsF);
   axis([0 3 0 1]);
   
   suffix ='';
    if strcmp(correctResult,'N');
        suffix = '_NORMAL';
    end
    
    if strcmp(correctResult,'A');
        suffix = '_AFib';
    end
    
     if strcmp(correctResult,'O');
        suffix = '_O';
    end
   
   
   
   hold off
   hgexport(FigHandle, [recordName,suffix,'.png'], hgexport('factorystyle'), 'Format', 'png');
   
  % if doTable()
   close(FigHandle);
  % end
end
  
if doTable 
   
   logFileName = 'ver_209_invs_big2_CNNiNN.txt';
    
   createHeaders = 0;
   fileEx = exist(logFileName, 'file');
  
   if  fileEx== 0
       createHeaders = 1;
   end
    
    
   fid = fopen(logFileName,'at');

  %RawMedAMean = mean(qrsResults.avgShapeRAW(startA:endA));
%RawMedAstd

   if createHeaders 
   fprintf(fid,'%s;', 'Filename');
   fprintf(fid,'%s;%s;%s;%s;','OUTCOME1','OUTCOME2','OUTCOME3','OUTCOME4');
   fprintf(fid,'%s;%s;%s;','correctResult','classifyResult','classifyCode');
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'pksMd', 'pksP7', 'pksP9','pksR1','pksR2','pksR3');
   
  fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;', 'signalMAD', 'signalMADrVR','madMin','madMax','madMed','madSTD','madVRMin','madVRMax','madVRMed','madVRStd');

   
 fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;', 'signalSTD','signalVR','signalSTDvrRatio','signalLNG','signalNumPeaks','signalNPlngRatio', 'signalPKmed', 'signalPKiqr', 'signalPKstd');

   fprintf(fid,'%s;%s;%s;%s;%s;', 'recordBPM','countRRs','stdRRs','RRcoverage','RRcoverage3');
    fprintf(fid,'%s;%s;%s;%s;','longestBlockOverBPM','rrCompMean', 'rrCompVR','rrCompStd');
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;','irregMax','irregCnt','irregMean','irregRatio','fbMax','holeMax');
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;','minRTE','maxRTE','medRTE','vrRTE','stdRTE','mmRTE');

 
   fprintf(fid,'%s;%s;%s;%s;%s;%s;','avgRAWdl1','avgRAWdl2','avgRAWdr2','avgRAWpwd','avgRAWrwd','avgRAWtwd');
   fprintf(fid,'%s;%s;%s;%s;%s;%s;','avgRAW2dl1','avgRAW2dl2','avgRAW2dr2','avgRAW2pwd','avgRAW2rwd','avgRAW2twd');

   
   fprintf(fid,'%s;%s;%s;', 'dRRsMEAN','dRRsSTD','qrsCountRatio');
   
    fprintf(fid,'%s;%s;%s;','histRRh2', 'histRRelevH2','histRRh2w');
   
   fprintf(fid,'%s;%s;%s;', 'RRextraDS','RRextraRatio','RRextrasCount');

   fprintf(fid,'%s;%s;%s;%s;', 'extraRRsCNT','extraRRsMin','extraRRsMax','exToAll'); 
   
   fprintf(fid,'%s;%s;%s;%s;%s;', 'maxRRs','medRRs','minRRs','vrRRs','longRRratio'); 
   
   fprintf(fid,'%s;%s;%s;', 'elevationRAW.elevationAbs','elevationRAW.elevationRel','elevationRAW.timeDist');
   
   fprintf(fid,'%s;%s;%s;%s;', 'invalidRatio','stdRRsL2','dRRsL2','maxKESrisk');

   fprintf(fid,'%s;%s;%s;', 'qrs1ratioLFMF','qrs2ratioLFMF','qrs12ratioLFMF');
   
   fprintf(fid,'%s;%s;%s;%s;%s;', 'groupCount','qrs1Count','qrs2Count','qrsAllCount','grpCountRatio');
   
   fprintf(fid,'%s;%s;%s;%s;', 'groupCountL2','groupCountL3','groupCountL4','groupCountL5');
   
   fprintf(fid,'%s;%s;%s;%s;', 'ratioQRS1toAll','ratioQRS2toAll','ratioQRS2to1','ratioQRS12toAll');
   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;', 'trustworthSTDmin','trustworthSTDmax','trustworthSTDmed','trustworthSTDstd','trustworthBPM','trustworthMFstd','diffBPMs');

   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;', 'trustworthVR','trustwrothNExToAll','trustworthAMPstd','trustworthAMPvr','trustwrothAMPNExToAll','trustworthRatioSTD','trustworthRatioVR','trustworthRatioEX');

   fprintf(fid,'%s;%s;%s;%s;', 'trustworthBPMmin','trustworthBPMmed','trustworthBPMmax','trustworthBPMstd');

   fprintf(fid,'%s;%s;%s;%s;%s;%s;','trustworthC0Cmin','trustworthC0Cmax','trustworthC0Cavg','trustworthC0Smin','trustworthC0Smax','trustworthC0Smed');

   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;','trustworthXDmin','trustworthXDmax','trustworthXDstd','trustworthXDmean','trustworthXMmin','trustworthXMmax','trustworthXMstd','trustworthXMmean','trustworthXPmin','trustworthXPmax','trustworthXPstd','trustworthXPmean');

   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;','meanLRdist','stdLRdist','meanFreq','stdFreq','stdLRDm','stdLRSm','hqrsLRsum','hqrsFsum','stdLRFratio');
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'RawMedAMean','RawMedAstd','RawMedBMean','RawMedBstd','RawMedCMean','RawMedCstd');
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'RawMedAskw','RawMedAkrt','RawMedBskw','RawMedBkrt','RawMedCskw','RawMedCkrt');
   
   %ratioRawMedStdAB
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;', 'ratioRawMedStdAB','ratioRawMedStdBC','ratioRawMedStdAC','ratioRawMedStdABC','ratioRawMedStdABC2','ratioRawMedAC','ratioRawMedBC');
   
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'LFMedAMean','LFMedAstd','LFMedBMean','LFMedBstd','LFMedCMean','LFMedCstd');
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'MFMedAMean','MFMedAstd','MFMedBMean','MFMedBstd','MFMedCMean','MFMedCstd');
   
   %rawNumExA a jhCorrRR
   fprintf(fid,'%s;%s;%s;%s;', 'rawNumExA','rawNumExB','rawNumExC','jhCorrRR');
   
  
   
  
    %Petrovy parametry
   fprintf(fid,'%s;%s;%s;%s;%s;%s;', 'featuresPetr.RRp10','featuresPetr.RRskew','featuresPetr.CQRSmean','featuresPetr.eQRSmax','featuresPetr.PwaveP2P','featuresPetr.PwaveRpp');
   
   
  fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;', 'pWaveAVG_VR','pWaveAVG_STD','pWaveAVG_Mean','pWaveSTD_med','pW1','pW2','pW3');
 
 fprintf(fid,'%s;%s;','avgRAW_VR','pWaveAVG_STD_NORM');
   
   %corr results
   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;', 'cts(1)','cts(2)','cts(3)','cts(4)','cts(5)','cts(6)','cts(7)','cts(8)','cts(9)','cts(10)','cts(11)','cts(12)','cts(13)','cts(14)','cts(15)', 'cts(16)','cts(17)','cts(18)','cts(19)','cts(20)','cts(21)','cts(22)','cts(23)','cts(24)','cts(25)','cts(26)','cts(27)','cts(28)','cts(29)','cts(30)');
   fprintf(fid,'%s;%s;','strongestCorrV','strongestCorr');

   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;', 'cts_2(1)','cts_2(2)','cts_2(3)','cts_2(4)','cts_2(5)','cts_2(6)','cts_2(7)','cts_2(8)','cts_2(9)','cts_2(10)','cts_2(11)','cts_2(12)','cts_2(13)','cts_2(14)','cts_2(15)', 'cts_2(16)','cts_2(17)','cts_2(18)','cts_2(19)','cts_2(20)','cts_2(21)','cts_2(22)','cts_2(23)','cts_2(24)','cts_2(25)','cts_2(26)','cts_2(27)','cts_2(28)','cts_2(29)','cts_2(30)');
   fprintf(fid,'%s;%s;%s;','strongestCorrV_2','strongestCorr_2','diffMaxCorrs');

   fprintf(fid,'%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;', 'cnns(1)','cnns(2)','cnns(3)','cnns(4)','cnns(5)','cnns(6)','cnns(7)','cnns(8)','cnns(9)','cnns(10)','cnns(11)','cnns(12)','cnns(13)','cnns(14)','cnns(15)', 'cnns(16)','cnns(17)','cnns(18)');
     
   fprintf(fid,'%s;%s;%s;%s;%s;', 'avgNsubMaxO','avgNsubMaxA','maxCodeNAO','maxCodeAvgNMaxAO','sumNprev');

   
   %outputNN
   fprintf(fid,'%s;%s;%s;', 'outputNN(1)','outputNN(2)','outputNN(3)');
   
   fprintf(fid,'%s\n', ' ');
   end
   
   
   str = [recordName ''];
   fprintf(fid,'%s;', str);
 

   
   out = ones(4,1);
   out(classifyCode)=-1; 
   fprintf(fid,'%1.0f;%1.0f;%1.0f;%1.0f;',out(1),out(2),out(3),out(4));
   
   fprintf(fid,'%s;%s;%1.0f;',correctResult,classifyResult,classifyCode);

  fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', pksMd, pksP7, pksP9,pksR1,pksR2,pksR3);
  fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', signalMAD, signalMADrVR,madMin,madMax,madMed,madSTD,madVRMin,madVRMax,madVRMed,madVRStd);
  
  fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', signalSTD,signalVR,signalSTDvrRatio,signalLNG,signalNumPeaks,signalNPlngRatio, signalPKmed, signalPKiqr, signalPKstd);
   
   if ~isnan(avrRR) && avrRR<3  && length(jhRR1)>1&& length(jhRR2)>1 && exist('featuresPetr','var') %%%%%%%% TODO formulace podmnky je vcensobn, to je patn
   
   fprintf(fid,'%1.3f;%1.0f;%1.5f;%1.3f;%1.3f;', recordBPM, countRRs, stdRRs,RRcoverage,RRcoverage3);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;',longestBlockOverBPM,rrCompMean, rrCompVR,rrCompStd);
   
    fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',irregMax, irregCnt,irregMean,irregRatio,fbMax,holeMax);
 
   
    fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',minRTE,maxRTE,medRTE,vrRTE,stdRTE,mmRTE);

   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',avgRAWdl1,avgRAWdl2,avgRAWdr2,avgRAWpwd,avgRAWrwd,avgRAWtwd);
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',avgRAW2dl1,avgRAW2dl2,avgRAW2dr2,avgRAW2pwd,avgRAW2rwd,avgRAW2twd);

    
   fprintf(fid,'%1.5f;%1.5f;%1.8f;', dRRsMEAN,dRRsSTD,qrsCountRatio);

 fprintf(fid,'%1.8f;%1.8f;%1.8f;',histRRh2, histRRelevH2,histRRh2w);


   fprintf(fid,'%1.8f;%1.8f;%1.8f;', RRextraDS,RRextraRatio,RRextrasCount);
   

   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', extraRRsCNT,extraRRsMin,extraRRsMax,exToAll); 


   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', maxRRs,medRRs,minRRs,vrRRs,longRRratio); 

   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;', elevationRAW.elevationAbs,elevationRAW.elevationRel,elevationRAW.timeDist);

   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', invalidRatio,stdRRsL2,dRRsL2,maxKESrisk);
   
    fprintf(fid,'%1.8f;%1.8f;%1.8f;', qrs1ratioLFMF,qrs2ratioLFMF,qrs12ratioLFMF);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', groupCount,qrs1Count,qrs2Count,qrsAllCount,grpCountRatio);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', groupCountL2,groupCountL3,groupCountL4,groupCountL5);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', ratioQRS1toAll,ratioQRS2toAll,ratioQRS2to1,ratioQRS12toAll);
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', trustworthSTDmin,trustworthSTDmax,trustworthSTDmed,trustworthSTDstd,trustworthBPM,trustworthMFstd,diffBPMs);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', trustworthVR,trustwrothNExToAll,trustworthAMPstd,trustworthAMPvr,trustwrothAMPNExToAll,trustworthRatioSTD,trustworthRatioVR,trustworthRatioEX);

   
fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', trustworthBPMmin,trustworthBPMmed,trustworthBPMmax,trustworthBPMstd);
   


fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',trustworthC0Cmin,trustworthC0Cmax,trustworthC0Cavg,trustworthC0Smin,trustworthC0Smax,trustworthC0Smed);

fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;',trustworthXDmin,trustworthXDmax,trustworthXDstd,trustworthXDmean,trustworthXMmin,trustworthXMmax,trustworthXMstd,trustworthXMmean,trustworthXPmin,trustworthXPmax,trustworthXPstd,trustworthXPmean);


   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', meanLRdist,stdLRdist,meanFreq,stdFreq,stdLRDm,stdLRSm,hqrsLRsum,hqrsFsum, stdLRFratio);

   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', RawMedAMean,RawMedAstd,RawMedBMean,RawMedBstd,RawMedCMean,RawMedCstd);
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', RawMedAskw,RawMedAkrt,RawMedBskw,RawMedBkrt,RawMedCskw,RawMedCkrt);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', ratioRawMedStdAB,ratioRawMedStdBC,ratioRawMedStdAC,ratioRawMedStdABC,ratioRawMedStdABC2,ratioRawMedAC,ratioRawMedBC);
   
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', LFMedAMean',LFMedAstd',LFMedBMean,LFMedBstd,LFMedCMean,LFMedCstd);
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', MFMedAMean',MFMedAstd',MFMedBMean,MFMedBstd,MFMedCMean,MFMedCstd);
      
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', rawNumExA,rawNumExB,rawNumExC,jhCorrRR);
%   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;', MF300MsCountMedian,IF300MsCountMedian,MF300MsCountSTD,IF300MsCountSTD);

   
   %Petrovy parametry2
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', featuresPetr.RRp10,featuresPetr.RRskew,featuresPetr.CQRSmean,featuresPetr.eQRSmax,featuresPetr.PwaveP2P,featuresPetr.PwaveRpp);
   
   
% pW1 = pWaveAVG_VR/pWaveSTD_med;
% pW2 = pWaveAVG_STD/pWaveSTD_med;
% pW3 = pWaveAVG_Mean/pWaveSTD_med;

   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', pWaveAVG_VR,pWaveAVG_STD,pWaveAVG_Mean,pWaveSTD_med,pW1,pW2,pW3);

% avgRAW_VR = max(avgRAW.shp)-min(avgRAW.shp);
% pWaveAVG_STD_NORM = pWaveAVG_STD/avgRAW_VR;
    fprintf(fid,'%1.8f;%1.8f;',avgRAW_VR,pWaveAVG_STD_NORM);
    
  
    allOneString = sprintf('%1.8f;' , cts);
    fprintf(fid,'%s',allOneString);
    fprintf(fid,'%1.8f;%1.8f;',strongestCorrV, strongestCorr);
    
    allOneString = sprintf('%1.8f;' , cts_2);
    fprintf(fid,'%s',allOneString);
    fprintf(fid,'%1.8f;%1.8f;%1.4f;',strongestCorrV_2, strongestCorr_2,diffMaxCorrs);
 
    allOneString = sprintf('%1.8f;', cnns);
    fprintf(fid,'%s',allOneString);
    
%     avgNsubMaxO = cnns(1)- cnns(9);
% avgNsubMaxA = cnns(1) - cnns(8);
% [mvcnn maxCodeNAO]= max(cnns(7:9));
% [mvcnn maxCodeAvgNMaxAO]= max([cnns(1) cnns(8:9)]);
% sumNprev = avgNsubMaxO*avgNsubMaxA;
%     
    %derived from CNN
   fprintf(fid,'%1.8f;%1.8f;%1.8f;%1.8f;%1.8f;', avgNsubMaxO,avgNsubMaxA,maxCodeNAO,maxCodeAvgNMaxAO,sumNprev);


    %outputNN
   fprintf(fid,'%1.8f;%1.8f;%1.8f;', outputNN(1),outputNN(2),outputNN(3));
  
 end
 
   fprintf(fid,'%s\n', ' ');

   fclose(fid);
end

if saveDetections
    
    flnm = [recordName,'_qrsobject','.mat'];
    
    save(flnm,'qrsResults');
    
    
end

end




