function [ CC ] = fastcorrcoef( T, D )
%I.Viscor, ISI of the CAS, Czech Republic
%part of Physionet/CinC 2017 challenge code
%FASTCORRCOEF Computes corrcoef of template T moving along data D.
%   [ CC ] = fastcorrcoef( T, D )
% T and D are columns vectors.
% One of T or D can be matrix, result is computed over each column.

NT=length(T);

T0=flipud(detrend(T,0));

onesNT=ones(NT,1);

MAD=conv2(onesNT,D);

MASD=conv2(onesNT,D.^2);

CC=conv2(T0,D)./sqrt((MASD-MAD.^2/NT)*sum(T0.^2));

CC=CC(NT:end-NT+1,:);

end

