function newLocs = findMissingShapes(signalCF,avgShape,corrSize,corrL,locs,sf)
%F.Plesinger, ISI of the CAS, Czech Republic
%part of Physionet/CinC 2017 challenge code

newLocs = 0;

cnst = constants(sf);

dataSize = length(signalCF);

lastQRSpos =-cnst.minQRSdist;
lastCorr = 0;
for startSample=1:dataSize-corrSize-1
    %je nkde blzko registrovan lokace?
    
    if startSample<lastQRSpos+cnst.minQRSdist
        continue;
    end
    
    endSample = startSample+corrSize;
    nearLocs = 0;
    
    for c=1:length(locs)
        if locs(c)>startSample && locs(c)<endSample
            nearLocs = c;
            break;
        end
    end
    
    if nearLocs >0
%         startSample = locs(nearLocs)+minQRSdist;
        lastQRSpos = startSample+fix(corrSize/2);
        continue;
    end
    
    testedBlock = signalCF(startSample:endSample-1);
    
       crc  = corrcoef(testedBlock,avgShape.');
       corr = crc(1,2); 
    
     
     cp = (fix(corrSize/2));
     cvAVG = avgShape(cp);
     cvTST = testedBlock(cp);
       
     ampRat = cvTST/cvAVG;
     
     if lastCorr>corr && lastCorr>0.94 && ampRat>0.25
          
         
          newLocs(length(newLocs)+1)=startSample+corrL-1;
        
          lastCorr = 0;
          
          lastQRSpos = startSample+fix(corrSize/2);
          
     end
    
    lastCorr=corr;
end




newLocs(1)=[];

end

