function res = getElevation(avgOBJ,fs)
%Vrac elevaci
%F. Plesinger 2017

% res.shp = avgShape./addedToSum;
% res.QRS300BefMed = median(numEX300);
% res.QRS300BefStd = std(numEX300);
% res.time = (1:blockSize)./fs-leftRad/fs;


shape = avgOBJ.shp;

avgSize = length(shape);

center = fix(avgSize/2);

rad100ms = fix(0.1*fs);
rad10ms = fix(0.02*fs);


VRqrs = max(shape(center-rad100ms:center+rad100ms))-min(shape(center-rad100ms:center+rad100ms));

winLength = rad10ms*2;

rightStart = center;

for x=center:center+3*rad100ms
    win = x:(x+winLength);
    cVR = max(shape(win))-min(shape(win));
    rat = cVR/VRqrs;
    if rat<0.1
        rightStart = x;
        break;
    end
end

leftStart = center-winLength;

for x=(center-winLength):-1:(center-3*rad100ms-winLength)
    win = x:(x+winLength);
    cVR = max(shape(win))-min(shape(win));
    rat = cVR/VRqrs;
    if rat<0.05
        leftStart = x;
        break;
    end
end

res.leftWin = leftStart:(leftStart+winLength);
res.rightWin = rightStart:(rightStart+winLength);

mLeft = mean(shape(res.leftWin));
mRight = mean(shape(res.rightWin));
res.elevationAbs = abs(mRight-mLeft); %%abs
res.elevationRel = res.elevationAbs/VRqrs;
res.timeDist = (rightStart-leftStart)/fs;


end

