function chanResult = getQRS_SAMECG(signal,signalForAveraging, invalid,fs)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

dataSize = size(signal,1)-1;

chanResult.qrs=[];
chanResult.group=[];
chanResult.rr=[];
chanResult.lfMaxLength=0;


avgLeft = 0.5*fs;
avgRight = 0.5*fs;

avgLength = avgLeft+avgRight;

chanResult.avgShapeLF = zeros(avgLength,1);
chanResult.avgShapeMF = zeros(avgLength,1);
chanResult.avgShapeHF = zeros(avgLength,1);


dataLF = hobalka(signal.*(1-invalid),fs,1,8).*(1-invalid);
dataMF = hobalka(signal.*(1-invalid),fs,5,25).*(1-invalid);
dataIF = hobalka(signal.*(1-invalid),fs,25,45).*(1-invalid);
dataHF = 0.25*hobalka(signal.*(1-invalid),fs,45,65).*(1-invalid); %orig 0.05

chanResult.dataMF = dataMF;
chanResult.dataHF = dataHF;

minPeakDistance = 0.32 * fs; %0.11
statRawSamples = 0.12 * fs;% //--velikost okna pro posuzovn statistiky surovch dat - krtkodob oblast
statRawLongSamples = 0.5 * fs; % //--dlouhodob oblast 0.5*250

statRawKVR = 0.20 ;% //-- nejmen pomr mezi VR krtk a dlouh oblasti 0.5
kHFminRation = 1;% //--kolikrt mus bt MF sloka u ECG vt ne HF sloka, aby byl peak pijat jako potenciln znaka

rMin = 0.025; %//--nejmen vka peaku, detekovanho na ECG oblce v rozdlu R=MF-LF 0.03

dataR = max(dataMF-dataHF,0);



[peaks,locs] = findpeaks(dataR);



% vyberu jen ty sprvn peaky
lastAcceptedPos = -minPeakDistance;

acceptedX = [];
acceptedY = [];

acceptedNum=1;

statPerc95 = prctile(dataR.*(1-invalid),50); %95 orig

signalP10 = prctile(signal.*(1-invalid),10);
signalP90 = prctile(signal.*(1-invalid),90);
vrP1090 = signalP90-signalP10;

for i=1:size(locs,1)
    
    accept = true;
    
    testedPos = locs(i); %index prv testovan pozice
    
    if invalid(testedPos)==1 continue % pokud extrem le v invalid oblasti, tak ho neem //oprava!!!!!
    end
    
    if (testedPos<3) || (testedPos>length(signal)-3)  %ignoruji peaky, kter by byly pmo na kraji. To smrd.
        continue
    end
    
    
    
    statRawStart = max(locs(i)-floor(statRawSamples/2),1);
    statRawEnd = min (locs(i)+floor(statRawSamples/2),size(signal,1));
    
    statRawLongStart = max(locs(i)- floor(statRawLongSamples/2),1);
    statRawLongEnd = min (locs(i)+ floor(statRawLongSamples/2),size(signal,1));
    
    statRawBlockShort = dataR(statRawStart:statRawEnd);
    statSignalBlockShort = signal(statRawStart:statRawEnd);
    statRawBlockLong = dataR(statRawLongStart:statRawLongEnd);
    
    shortBlockVR =  max(statRawBlockShort)-min(statRawBlockShort);
    longBlockVR = max(statRawBlockLong)-min(statRawBlockLong);
    
    accept = accept && (testedPos>lastAcceptedPos+minPeakDistance); %oeten proti pli blkm peakm
    accept = accept && (dataR(testedPos)>= kHFminRation * dataHF(testedPos)); %oeten proti rychlm kmitm
    accept = accept && (dataR(testedPos)>=rMin); %oeten proti pli slabm peakm
    accept =accept && (dataR(testedPos) > statPerc95); %kontrola na velikost v rmci statistiky vyetovanch 10 sekund
    
    accept = accept && (shortBlockVR>longBlockVR*statRawKVR);
    
    accept = accept && (max(statRawBlockShort) == max (statRawBlockLong));
     
    %kontrola, e to nesoused s nevalidn oblast
    accept = accept && (dataR(testedPos+2)>0) && (dataR(testedPos-2)>0);
    
    
    %kontrola, e to nen ve svisl siln hran - NOVE CINC 2017
    lng = length(statSignalBlockShort);
    center = fix(lng/2);
    leftPart = statSignalBlockShort(center) - mean(statSignalBlockShort(1:center));
    rightPart = statSignalBlockShort(center) - mean(statSignalBlockShort(center:lng-1));
    
    elevation = abs(leftPart-rightPart);
    
    accept = accept && elevation<vrP1090*4;
    
    if (accept)
        
        acceptedX(acceptedNum) = testedPos;
        acceptedY(acceptedNum) = peaks(i);

        %toto se bude muset jet pozdji opravit
        chanResult.group(acceptedNum) = dataLF(testedPos)>dataR(testedPos);
        
        lastAcceptedPos = testedPos;
        
        acceptedNum = acceptedNum+1;
        
    end
end






%odstrann ppadnch T vln. lo by to pes find==0

numGroup2=find(chanResult.group==1);

if (acceptedNum>10 && size(numGroup2,2)>5)
numRT = 1;

for i=2:acceptedNum-1 

    if chanResult.group(i)==0 || chanResult.group(i-1)==1
        continue;
    end
    %sem projdou jen kombinace 0-1
    rtDists(numRT) = (acceptedX(i)-acceptedX(i-1))/fs;
    numsToRemove(numRT) = i;
    numRT = numRT+1;
end

% exist('testresults','var')
if exist ('rtDists','var') && size(rtDists,2)>5

meanRT = mean(rtDists);
stDevRT = std(rtDists);

minRT = min(rtDists);
maxRT = max(rtDists);

limitSTD = 0.03;

if meanRT<0.55 && meanRT>0.25 && minRT>0.15 && maxRT<0.6 && stDevRT<limitSTD

    acceptedX(numsToRemove)=[];
    acceptedY(numsToRemove)=[];
    chanResult.group(numsToRemove)=[];
end

end
end

numQRS = length(acceptedX);

% chanResult.qrs = acceptedX;
% chanResult.rr = diff(chanResult.qrs)/fs;





% nalezen nejdelho LF bloku
lfStart=1;
lfEnd=1;
maxLFlength=0;
maxLFstart=0;
maxLFend = 0;

for i=1:length(dataLF)
    if ((dataLF(i)<dataR(i)) || (invalid(i)==1))
        
        lfEnd = i;
        
        lfLength = lfEnd-lfStart;
        
        if (lfLength>maxLFlength)
            maxLFstart = lfStart;
            maxLFend = lfEnd;
            maxLFlength = lfLength;
        end
        
        lfStart=i;
        continue
    end
    lfEnd = i;
end

if ((dataLF(end)>dataR(end)) || (lfEnd>0))
      lfLength = lfEnd-lfStart;
        if (lfLength>maxLFlength)
        maxLFstart = lfStart;
        maxLFend = lfEnd;
        maxLFlength = lfLength;
        end
end

maxLFlength = maxLFlength/fs;
chanResult.lfMaxLength=maxLFlength;


%redukce roztesen


avcL = 0.15*fs;
avcR = 0.15*fs;
avcT = avcL+avcR;

dataAVG=zeros(numQRS,avcT);
dataAVGsignal=zeros(numQRS,avcT);

for i=1:numQRS
  
    dataStart = acceptedX(i)-avcL;
    dataEnd = acceptedX(i)+avcR-1;
    
    if dataStart<1
        continue;
    end
    
    if dataEnd>=dataSize-1
        continue;
    end
    
    locData = (dataMF(dataStart:dataEnd)).';
    dataAVG(i,:)= locData ;
    dataAVGsignal(i,:)=(signalForAveraging(dataStart:dataEnd)).';
    
end

for s=1:avcT
    chanResult.simpleAVG(s) = mean(dataAVG(:,s));
    chanResult.simpleAVGsignal(s) = mean(dataAVGsignal(:,s));
end


corrRad = 0.1*fs; %radius korelace

indexesToRemove=0;



for i=1:numQRS
  
    corrField=zeros(corrRad*2,1);
    
    
    
    for sample=1:corrRad*2
        
        offset = sample-corrRad;
        
        corStart = acceptedX(i)+offset-avcL;
        corEnd = acceptedX(i)+offset+avcR-1;
    
    if corStart<1
        continue;
    end
    
    if corEnd>=dataSize-1
        continue;
    end

    
       crc = corrcoef(dataMF(corStart:corEnd),chanResult.simpleAVG.');
    
    corrField(sample) = crc(1,2); 
    
    end    
    
    
    [cy cx] = max(corrField);
    
    if cy<0.65
        indexesToRemove(length(indexesToRemove)+1)=i;
    else
    
        if cx>1 && cx<corrRad*2-1
            fof = cx-corrRad;
            acceptedX(i)=acceptedX(i)+fof;
        end
    end
    
end

indexesToRemove(1)=[];

if length(indexesToRemove)>0
acceptedX(indexesToRemove)=[];
acceptedY(indexesToRemove)=[];
end
% konec redukce roztesen

numQRS = length(acceptedX);


%%%%%%% vyjmut pebytench QRS

chanResult.removedQRS = 0;

avsL = fix(avcT*0.25);
avsR = fix(avcT*0.75);

shorterAVG = chanResult.simpleAVGsignal(avsL:avsR);
saVR = max(shorterAVG)-min(shorterAVG);


for k=1:2

rrs = diff(acceptedX);

medianRR = median(rrs);
indexesToRemove=0;

minLimit = 0.7*fs;

for i=1:length(rrs)-1;

  cr = rrs(i);
  nr = rrs(i+1);
  

  if cr>minLimit
      continue;
  end

  tr = cr+nr;
  
  dim = abs(medianRR-tr);

  corToAVG=1;
  
  
  
  centerT = acceptedX(i+1);
  if centerT-avcL>1
  blockTested = signalForAveraging(centerT-avsL:centerT+avsL+1);
  crc = corrcoef(blockTested,shorterAVG.');
  corToAVG = crc(1,2);   
  end
  
  btVR = max(blockTested)-min(blockTested);
  
  
  if dim<medianRR*0.7 && (corToAVG<0.4 && btVR*2<saVR)
      indexesToRemove(length(indexesToRemove)+1)=i;
  end
    
end

indexesToRemove(1)=[];

chanResult.removedQRS = [chanResult.removedQRS acceptedX(indexesToRemove+1)];



if length(indexesToRemove)>0
acceptedX(indexesToRemove+1)=[];
acceptedY(indexesToRemove+1)=[];
end

end

chanResult.removedQRS(1) = [];

% konec redukce roztesen



%%%%%%% doplnn chybjcch QRS %%%%%%
% 
% medL = 0.1*fs;
% medR = 0.1*fs;
% medT = medL+medR;
% 
% dataMED=zeros(numQRS,medT);
% 
% for i=1:numQRS
%   
%     dataStart = acceptedX(i)-medL;
%     dataEnd = acceptedX(i)+medR-1;
%     
%     if dataStart<1
%         continue;
%     end
%     
%     if dataEnd>=dataSize-1
%         continue;
%     end
%     
%     locData = (signal(dataStart:dataEnd)).';
%     dataMED(i,:)= locData ;
% end
% 
% for s=1:medT
%     chanResult.simpleMED(s) = median(dataMED(:,s));
% end
% 
% %prokorelovat cel signl 
% minDistQRS = 0.220;
% 
% cc = zeros(length(signal),1);
% 
% for sample=medL:fix(length(signal)-medR)
%         
%         corStart = sample-medL;
%         corEnd = sample+medR-1;
%     
%     if corStart<1
%         continue;
%     end
%     
%     if corEnd>=dataSize-1
%         continue;
%     end
% 
%     
%     crc = corrcoef(signal(corStart:corEnd),chanResult.simpleMED.');
%     
%     cc(sample) = crc(1,2); 
%     
% end    
% 
% 
% for s=fix(minDistQRS*fs):length(fix(signal-minDistQRS*fs))
%     
%     lastQRSat = -minDistQRS*fs;
%     lastQRSi = 0;
%     
%     for q=1:numQRS
%         if acceptedX(q)>s
%             break;
%         end
%         
%         lastQRSat = acceptedX(q);
%         lastQRSi = q;
%     end
%     
%     dist = s-lastQRSat;
%     if dist<minDistQRS*fs
%         continue;
%     end
%     
% end



%%%%% konec doplnn chybjcch QRS

numQRS = length(acceptedX);
chanResult.qrs = acceptedX;
chanResult.rr = diff(chanResult.qrs)/fs;

%%%%%%%%% prmrovn tvar %%%%%%%%%%%%%

dataContainerRAW=zeros(numQRS,avgLength);
dataContainerLF=zeros(numQRS,avgLength);
dataContainerMF=zeros(numQRS,avgLength);
dataContainerIF=zeros(numQRS,avgLength);
dataContainerHF=zeros(numQRS,avgLength);

for i=1:numQRS
  
    dataStart = acceptedX(i)-avgLeft;
    dataEnd = acceptedX(i)+avgRight-1;
    
    if dataStart<1
        continue;
    end
    
    if dataEnd>=dataSize-1
        continue;
    end
    
    locData = (signalForAveraging(dataStart:dataEnd)).';
    dataContainerRAW(i,:)= locData ;
    locData = (dataLF(dataStart:dataEnd)).';
    dataContainerLF(i,:)= locData ;
    locData = (dataMF(dataStart:dataEnd)).';
    dataContainerIF(i,:)= locData ;
    locData = (dataIF(dataStart:dataEnd)).';
    dataContainerMF(i,:)= locData ;
    locData = (dataHF(dataStart:dataEnd)).';
    dataContainerHF(i,:)= locData ;
end

chanResult.avgShapeLF = zeros(avgLength,1);



for s=1:avgLength
    chanResult.avgShapeRAW(s) = median(dataContainerRAW(:,s));
    chanResult.avgShapeLF(s) = median(dataContainerLF(:,s));
    chanResult.avgShapeMF(s) = median(dataContainerMF(:,s));
    chanResult.avgShapeIF(s) = median(dataContainerIF(:,s));
    chanResult.avgShapeHF(s) = median(dataContainerHF(:,s));
    
    chanResult.stdShapeRAW(s) = std(dataContainerRAW(:,s));
    chanResult.stdShapeLF(s) = std(dataContainerLF(:,s));
    chanResult.stdShapeMF(s) = std(dataContainerMF(:,s));
    chanResult.stdShapeIF(s) = std(dataContainerIF(:,s));
    chanResult.stdShapeHF(s) = std(dataContainerHF(:,s));
    
    chanResult.avgShapesTime(s) = (s-avgLeft)/fs;
end






%korelace k nsledujcmu
for i=1:numQRS-1
  
    dataStart =fix(acceptedX(i)-avgLeft/2);
    dataEnd =fix(acceptedX(i)+(avgRight-1)/2);
    
    if dataStart<1
        continue;
    end
    
    if dataEnd>=dataSize-1
        continue;
    end
    
    dataStart2 =fix(acceptedX(i+1)-avgLeft/2);
    dataEnd2 =fix(acceptedX(i+1)+(avgRight-1)/2);
    
    if dataStart2<1
        continue;
    end
    
    if dataEnd2>=dataSize-1
        continue;
    end
   
    crc = corrcoef(signal(dataStart:dataEnd),signal(dataStart2:dataEnd2));
    
    chanResult.corrs(i) = crc(1,2); 
end

if numQRS>1
chanResult.corrs(numQRS) = 0;
else
chanResult.corrs = [];
end


%poet maxim na MF a IF 300 ms ped QRS pro kad tep
for i=1:numQRS
    startIndex = acceptedX(i)-0.300*fs;
    endIndex = acceptedX(i)-0.1*fs;

    if endIndex<1
        continue;
    end
    
    if startIndex<1 
        startIndex = 1;
    end
    
    thresholdMF =0;% prctile(dataMF(startIndex:endIndex),1);
    thresholdIF =0;% prctile(dataIF(startIndex:endIndex),1);
    
    peaksMF = findpeaks(dataMF(startIndex:endIndex),'Threshold',thresholdMF);
    
    chanResult.MFextremsBeforeQRS(i)=length(peaksMF);
    chanResult.IFextremsBeforeQRS(i)=length(findpeaks(dataIF(startIndex:endIndex),'Threshold',thresholdIF));
end

end




