function [ out ] = parameter_extractor( val )

%% Autocorelation paramaters are named as CorrParamaterName
rxx=xcorr(val);
Rxx=abs(fft(rxx));
Rxx=Rxx(1:fix(end/2)+1);


%% Estimation of parameters with DC component

%spectrum prob density function pdf
CorrEnergy=sum(Rxx);
out.CorrEnergy_per_sample=CorrEnergy/length(Rxx);
Corrpdf=Rxx./CorrEnergy;
CorrCentroid=0;
CorrEntropy=0;
out.CorrSdev=std(Corrpdf);
out.CorrKurtosis=kurtosis(Corrpdf);
out.CorrSkew=skewness(Corrpdf);

for i=1:length(Corrpdf)
    CorrEntropy=CorrEntropy+Corrpdf(i)*log(Corrpdf(i));
    CorrCentroid=CorrCentroid+i*Corrpdf(i);
end
out.CorrEntropy=-CorrEntropy;
out.CorrCentroid=CorrCentroid/length(Rxx);


%% Estimation of parameters WITHOUT DC component

%spectrum prob density function pdf
Rxx(1)=0.000000001;
CorrEnergy_noDC=sum(Rxx);
out.CorrEnergy_per_sample_noDC=CorrEnergy_noDC/length(Rxx);
Corrpdf_noDC=Rxx./CorrEnergy_noDC;
CorrCentroid_noDC=0;
CorrEntropy_noDC=0;
out.CorrSdev_noDC=std(Corrpdf_noDC);
out.CorrKurtosis_noDC=kurtosis(Corrpdf_noDC);
out.CorrSkew_noDC=skewness(Corrpdf_noDC);

for i=1:length(Corrpdf_noDC)
    CorrEntropy_noDC=CorrEntropy_noDC+Corrpdf_noDC(i)*log(Corrpdf_noDC(i));
    CorrCentroid_noDC=CorrCentroid_noDC+i*Corrpdf_noDC(i);
end
out.CorrEntropy_noDC=-CorrEntropy_noDC;
out.CorrCentroid_noDC=CorrCentroid_noDC/length(Rxx);

end

