function res = qrsCorrDet( signal,fs,checkTwaves,invalid, recordName)
%Detection of QRS peaks based on correlation and variation range
%

res.rr_tw = [];

res.rr_1 = [];
res.qrsTable = [];
res.twSequence = [];
res.group = [];

res.rr_tw_std_min = -1;
res.rr_tw_std_max = -1;
res.rr_tw_std_med = -1;
res.rr_tw_std_std = -1;

res.rr_tw_bpms_min = -1;
res.rr_tw_bpms_med = -1;
res.rr_tw_bpms_max = -1;
res.rr_tw_bpms_std = -1;

res.rr_tw_c0c_min = -1;
res.rr_tw_c0c_max = -1;
res.rr_tw_c0c_avg = -1;

res.rr_tw_c0a_min = -1;
res.rr_tw_c0a_max = -1;
res.rr_tw_c0a_avg = -1;

res.rr_tw_c0s_min = -1;
res.rr_tw_c0s_max = -1;
res.rr_tw_c0s_med = -1;



res.rr_xd_min = -1;
res.rr_xd_max = -1;
res.rr_xd_std = -1;
res.rr_xd_mean = -1;

res.rr_xm_min = -1;
res.rr_xm_max = -1;
res.rr_xm_std = -1;
res.rr_xm_mean = -1;

res.rr_xp_min = -1;
res.rr_xp_max = -1;
res.rr_xp_std = -1;
res.rr_xp_mean = -1;

res.qrs_1 = [];
res.qrs_all = [];
res.rr_all=[];

res.qrs_12 = [];
res.rr_12 = [];

res.qrs_complete=[];
res.rr_complete=[];

res.rrRatios = [];

res.KESrisk = [];

res.KESr2 = [];
res.KESsMF = [];

signalMF = hobalka(signal,fs,8,30); %orig 8 %%%%% UPRAVA !!!!! vs 5 8ok
signalLF = hobalka(signal,fs, 1,6); 

signalCF = hfilta(signal,fs,2,30);
%signalCF = signal;   %%% UPRAVA !!!!!!

[vals locs] = findpeaks(signalMF,'SortStr','descend','MinPeakDistance',0.15*fs);

% pokus se zmnou psma
% [valsLF locsLF] = findpeaks(signalLF,'SortStr','descend','MinPeakDistance',0.15*fs);
% 
% sortedLocs = sort(locs);
% sortedLFlocs = sort(locsLF);
% 
% stdMF = std(sortedLocs);
% cntMF = length(locs);
% 
% stdLF = std(sortedLFlocs);
% cntLF = length(locsLF);


%



winL = fix(0.30*fs);
winR = fix(0.30*fs);

winTL = fix(0.25*fs);
winTR = fix(0.25*fs);



indexesToRemove = 0;
severeIndexesToRemove = [];

dataSize = length(signal);

for i=1:length(locs)
    
    center = locs(i);
    centerVal = signalMF(center);
    
    startSample = center-winL;
    endSample = center+winR;
    
    
    
    
    
    if startSample<1 || endSample>=dataSize %kontrola na okraj dat
        indexesToRemove(length(indexesToRemove)+1)=i;
        severeIndexesToRemove(length(severeIndexesToRemove)+1)=i;
        continue
    end
    
   
    
    
    block = signalMF(startSample:endSample);
    
    if max(block)>centerVal*1.5 %kontrola na velikost vrcholu
        indexesToRemove(length(indexesToRemove)+1)=i;
        severeIndexesToRemove(length(severeIndexesToRemove)+1)=i;
        continue
    end
    
    
    %% kontrola na smrodatnou odchylku B>>A && B>>C
    totSize = winL+winR;
    endA = fix(totSize/3);
    endB = endA*2;
    
    blockA = block(1:endA);
    blockB = block(endA:endB);
    blockC = block(endB:totSize);
    
    stdA = std(blockA);
    stdB = std(blockB);
    stdC = std(blockC);
    
    if (stdA+stdC)>stdB
         indexesToRemove(length(indexesToRemove)+1)=i;
         continue;
    end
    
    
    
    
    %% kontrola na ptomnost T vlny vpravo pomoc symetrie
    startLA = center-winTL;
    endRA = center+winTR;
    
    blockTL = signalLF(startLA:center);
    blockTR = signalLF(center:endRA);
    
    if sum(blockTL)>sum(blockTR)*1.5
        indexesToRemove(length(indexesToRemove)+1)=i;
        continue
    end
end

indexesToRemove(1)=[];



if length(indexesToRemove)/length(locs)<0.95 %%%%%% VELICE NEPKN %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% kvli komorov tachykardii
locs(indexesToRemove)=[];
vals(indexesToRemove)=[];
else
locs(severeIndexesToRemove)=[];
vals(severeIndexesToRemove)=[];
end

%%%%%%%%% konec pedvbru vrchol %%%%%%%%


%%%%%%%%% korelace do skupin %%%%%%%%
corrL = fix(0.15*fs);
corrR = fix(0.15*fs);
corrSize = corrL+corrR+1;

corrFitRad = fix(corrSize/8);


%% zacatek vylepseni korelace 1 (ivo) %%

group = zeros(length(locs),1);

maxGroup = 1;

for i=1:length(locs) 
    
    if group(i)==0
        group(i)=maxGroup;
        maxGroup = maxGroup+1;
    end
    
    center = locs(i);
    startSample = center-corrL;
    endSample = center+corrR;
    
    if startSample<1 || endSample>dataSize
        continue;
    end
    
    origBlock = signalCF(startSample:endSample); 

    corrBlockM=[];
    groupCorr=[];
    
    for k=i+1:length(locs)          % pripravi data pro maticovou korelaci
        if group(k)>0 
            continue;
        end
    
        ct = locs(k);

        startC = ct-corrL-corrFitRad;
        endC = ct+corrL+corrFitRad;

        startCE = max(startC,1);
        endCE = min(endC,dataSize);

        corrBlockM = [corrBlockM zeros(corrL*2+corrFitRad*2+1,1)];
        groupCorr = [groupCorr k];
        
        corrBlockM(1+startCE-startC:end+endCE-endC,end) = ...
            signalCF(startCE:endCE);
        
    end
    
    if length(groupCorr)==0
        continue
    end
    
    corrsM = fastcorrcoef(origBlock,corrBlockM);    % maticova korelace
    
    [maxCM, offsM] = max(corrsM);

    for m=1:length(groupCorr)       % vyhodnoti maticovou korelaci

        if maxCM(m)>0.9
            k = groupCorr(m);
            
            group(k) = group(i);
            
            offset = offsM(m)-corrFitRad-1;
            locs(k) = locs(k)+offset;
        end
      
    end
    
end



%% konec vylepseni korelace 1 (ivo) %%





tg = maxGroup-1;



%%%%%%%% konec korelace do skupin %%%%%%%






%%%%%%%% slouen podobnch skupin



%% zacatek vylepseni korelace 2 (ivo) %%

% Puvodne je obraz vetsi nez vzor, to ted nepouzivam, takze
% se pouzije vzor(=obraz) o delce puvodniho vzoru

csL = fix(corrL/2);
csR = fix(corrR/2);

% puvodne
% ss = corrL-csL;
% es = corrL+csR;

% spravneji je stred takto
ss = corrL+1-csL;
es = corrL+1+csR;

corrShapeRad = csL; % vystup corr bude s delkou corrL nebo corrL+1

mergedGroup=[];

groupPositionOffset=zeros(tg,1);

numSecs = length(signal)/fs;

if tg>numSecs; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% rume, je moc skupin, tak je to asi blb.
    
    res.groupCounts = tg;
    return;
end


if length(locs)<4
    return;
end
                        % prepinac je mozne zapnout (1) nebo vypnout (0)
avg_after_merge = 1;    % prepocitavani avg po kazdem slouceni

merged = 2; % vychozi hodnota do cyklu while, aby se pocitalo avg a corr

while merged

    if merged==2 | avg_after_merge==1
        % na zacatku a volitelne po kazdem slucovani vypocist prumerne tvary
        % skupin a pak jejich korelace
 
        %prumerovani ze vsech skupin i tech zrusenych
        avgs = buildAvgShape(signalCF,locs,tg,corrL,corrR,group);

        %korelace jen z prezivajicich skupin
        
        shapeM=[];      %matice vzoru(=obrazu)
        groupCorr=[];   %vektor skupin pro korelaci
        allToCorr=zeros(tg,1); %vektor prekladu skupiny na skupinu pro korelaci

        for a =  1:tg

            if any(mergedGroup==a)
                continue;
            end
            
            shapeM = [shapeM avgs.avgShape(a,ss:es)'];
            groupCorr = [groupCorr a];
            allToCorr(a) = length(groupCorr);
                
        end
        
        groupCorrLen = length(groupCorr);
        
        shapeM = detrend(shapeM,0); % odstran DC - nutne pro corrcoef
   
        corrCurveM = xcorr(shapeM, corrShapeRad, 'coef');

        [maxvM maxlM] = max(corrCurveM);

    end % of if avg+corr
        

    merged = 0;
    
    for a =  1:tg-1
        
        if any(mergedGroup==a)
            continue;   % prazdnou skupinu preskocit
        end
        
        for b = a+1:tg
            
            if any(mergedGroup==b)
                continue;   % prazdnou skupinu preskocit
            end
            
            if avg_after_merge==1
                %mame korelace prezivajich skupin
                corrindex=(allToCorr(a)-1)*groupCorrLen+allToCorr(b); 
            else
                %mame porad jen korelace vsech skupin
                corrindex=(a-1)*tg+b; 
            end
           
            if maxvM(corrindex)>0.95  %0.95
                merged = true;
                break;
            end
            
        end
        
        if merged
            break;
        end
    end
    
    if merged
        offset = corrShapeRad+1-maxlM(corrindex);   
        locs(group==b) = locs(group==b)+offset;
        group(group==b) = a;
        mergedGroup = [mergedGroup b];
        
        for c=b+1:tg
            groupPositionOffset(c)=groupPositionOffset(c)-1;
        end
        
    end
end

%% konec vylepseni korelace 2 (ivo) %%



group = reorganizeGroups(group, groupPositionOffset);
groupCounts = computeGroupCounts(group); 
tg = max(group);


%%%%%%%%% vyhledan chybjcch QRS 

%prmrovn tvar
avgBuilder = buildAvgShape(signalCF,locs, tg,corrL,corrR,group);


%%%%%%%% samotn vyhledn chybjcch QRS %%%%%%%

%% zacatek vylepseni korelace 3 (ivo) %%

%nejprve maticova korelace vseho, pak vyhodnoceni

groupCorr = find(groupCounts>=2);  % skupiny ke korelaci

if length(groupCorr)>0
    
    testedAVGshapeM = avgBuilder.avgShape(groupCorr,:)';  % sloupec na skupinu
    
    corrM = fastcorrcoef(testedAVGshapeM,signalCF);     % maticova korelace
    
    cnst = constants(fs);
    cp = fix(corrSize/2);
 
    for i=1:length(groupCorr)
        
        [valsC locsC] = findpeaks(corrM(:,i));
        
        cvAVG = testedAVGshapeM(cp+1,i); %puvodne z cp, ale stred je cp+1 (prvni je 1)
        cvTST = signalCF(locsC+cp);        % (prvni je 0)
        ampRat = cvTST/cvAVG;
        
        locsCF = locsC(find( (valsC>0.94) & (ampRat>0.25) ));
        
        for j=1:length(locsCF);
            startSample = locsCF(j);
            endSample = startSample+corrSize-1;
            
            % puvodni podminka je nejasna - nyni je pevne min. vzdalenost
            % noveho QRS od stareho cnst.minQRSdist
            if min(abs(locsCF(j)+corrL-locs)) > cnst.minQRSdist
                % pridavame novy QRS         
                locs = [locs; locsCF(j)+corrL];
                group = [group; groupCorr(i)];
            end
            
        end
        
    end

end

%% konec vylepseni korelace 3 (ivo) %%





%%%%%%%%% odstrann amplitudov slabch a moc silnch QRS
if true

rad=fix(0.04*fs);

en_1=[];
L1 = locs(group==1);
n=length(L1);

for q=1:n
    en_1(length(en_1)+1)=sum(signalMF(L1(q)-rad:L1(q)+rad));
end

medMF = median(en_1);

idxToRemove=[];

for q=1:length(locs)
    
    if group(q)==1
        continue;
    end
    
    la = locs(q)-rad;
    lb = locs(q)+rad;
    
    sumMF=sum(signalMF(la:lb));
    
    if sumMF<medMF/5 || sumMF>medMF*4
         idxToRemove = ([idxToRemove' q])';
    end
    
end


locs(idxToRemove)=[];
group(idxToRemove)=[];

% reorganizace
group = reorganizeGroups(group, zeros(tg,1));
groupCounts = computeGroupCounts(group); 
tg = max(group);
% 

end





%%%%%%%%% zvren setdn QRS

qrsTable = zeros(2,length(locs));

qrsTable(1,:) = locs;
qrsTable(2,:) = group;

[Y,I] = sort(qrsTable(1,:));
qrsTable = qrsTable(:,I);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% detekce komorovek %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

locs = qrsTable(1,:);
group = qrsTable(2,:);



qn = length(locs);

qrs1 = locs(group==1);

rad = fix(0.1*fs);

sumsLF = zeros(length(qrs1),1);
sumsMF = zeros(length(qrs1),1);
sumsRW = zeros(length(qrs1),1);

for i=1:length(qrs1); %%%% medianov hodnota sum LF a MF pro majoritn skupinu
    
    cnt = qrs1(i);
    
    a = cnt-rad;
    b = cnt+rad;
    
    sumsLF(i) = sum(signalLF(a:b));
    sumsMF(i) = sum(signalMF(a:b));
    sumsRW(i) = sum(signal(a:b));
end

medSumLF_1 = median(sumsLF);
medSumMF_1 = median(sumsMF);
medSumRW_1 = median(sumsRW);

rrs1 = diff(qrs1)./fs;

rrs1 = rrs1(rrs1<2);

medianRR1 = median(rrs1);

KESrisk = zeros(qn,1);

for i=2:qn-1;
   %%%% povolit to pro vechny skupiny?????
    
   if group(i-1)~=1 
       continue;
   end
   
   if group(i)~=2
       continue;
   end
    
   a = locs(i-1);
   b = locs(i+1);
 
    
    center = locs(i);
    
    t0 = (center-a)/fs;
    t1 = (b - center)/fs;
    
    if t0>medianRR1*0.8 %% pokud je pedek del jak major, konm
        continue;
    end
    
    if t0>t1*0.8 %% pokud je pedek del ne zadek, konm
        continue;
    end
    
    if (t0+t1)*0.8<medianRR1 %% pokud je souet krat ne major, konm
        continue;
    end
    
    sumMF = sum(signalMF(center-rad:center+rad));
    
    
    if sumMF>medSumMF_1*1.2 %pokud je MF energie vt jak major, koonm
        continue;
    end
    
    sumLF = sum(signalLF(center-rad:center+rad));
    
    KESrisk(i) = sumLF/medSumLF_1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


KESrisk2 = zeros(qn,1);
KESsumMF = zeros(qn,1);

for i=1:qn; %%opakovan kvli plynul hodnot
    center = locs(i);
    sumMF = sum(signalMF(center-rad:center+rad));
    sumLF = sum(signalLF(center-rad:center+rad));
    KESrisk2(i) = sumLF/sumMF;
    KESsumMF(i) = sumMF;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
res.KESr2 = KESrisk2;
res.KESsMF = KESsumMF;


%%%%%%%%% vyeten RR ratios
rrs = diff(locs)./fs;
rrCount = length(rrs);

rrRatios = zeros(rrCount,1);

rad = fix(0.1*fs);

for r=1:rrCount-1
    
    t0 = rrs(r);
    t1 = rrs(r+1);
    
    ratio = t0/t1;
    
    if group(r)~=1 || group(r+1)~=1
        continue;
    end
    
    if ratio>0.7 && ratio<1.3 %% je to v norm, jdu dl
        continue;
    end
    
    if t0<medianRR1*1.0 && t1<medianRR1*1.0
        continue;
    end
    
    locA = locs(r);
    locB = locs(r+1);
    locC = locs(r+2);
    
    beatAMF = max(signalMF(locA-rad:locA+rad));
    beatBMF = max(signalMF(locB-rad:locB+rad));
    beatCMF = max(signalMF(locC-rad:locC+rad));
    
    meanBeatMF = (beatAMF+beatBMF+beatCMF)/3;
    
    area0 = locA+2*rad:locB-2*rad;
    area1 = locB+2*rad:locC-2*rad;
    
    if length(area0)*length(area1)==0
        continue;
    end
    
    max0 = max(signalMF(area0));
    max1 = max(signalMF(area1));
    
    if max0<meanBeatMF/4 && max1<meanBeatMF/4
        rrRatios(r) = ratio;
    end
    
end

res.rrRatios = rrRatios;

%%%%%%%%%

%%%%%%%%% TRUSTWORTHY BLOCK = 6 tep s co nejmen STD; jen pro majoritn
%%%%%%%%% skupinu

majLocs=qrsTable(1,:); 

neededQRS = min([6,length(majLocs)-1]); %pvodn 6, po upozorneni od Ivose opraveno
%neededQRS = 6;


stds = [];
twbpms = [];
c0count = [];
c0avgRat = [];
c0avgStep = [];
xDiff = [];
xMom = [];
xPrev = [];

for trustStart = 1:length(majLocs)-neededQRS
    
    trustEnd = trustStart+neededQRS;
    block =majLocs(trustStart:trustEnd);
    blockRRs = diff(block)./fs;
    
    stds(trustStart)=std(blockRRs);
    twbpms(trustStart)=60/(mean(blockRRs));
    
    blockRRavg = mean(blockRRs);
    blockRRsgn =sign(blockRRs-blockRRavg);
    
    chngs=[];
    
    for t=2:length(blockRRs)
     if blockRRsgn(t-1)~=blockRRsgn(t)
         chngs(length(chngs)+1)=abs(blockRRs(t-1)-blockRRs(t));
     end
    end    
    
    c0count(trustStart)=length(chngs);
    c0avgRat(trustStart)=c0count(trustStart)/length(blockRRs);
    
    c0avgStep(trustStart)=mean(chngs);
    
    if isnan(c0avgStep(trustStart)) 
        c0avgStep(trustStart)=0;
    end
    
    %%%% vypocet tezist
    
    xt = blockRRavg;
    
    dataLeft = blockRRs(blockRRs<xt-0.000001);
    dataRight = blockRRs(blockRRs>xt+0.000001);
    
    xDiff(trustStart) = mean(dataRight)-mean(dataLeft);
    
    if (isnan(xDiff(trustStart)))
        xDiff(trustStart)=0;
    end
    
    moments = abs(blockRRs-xt);
    
    xMom(trustStart) = sum(moments);
    
    mn = xt-0.05;
    mx = xt+0.05;
    
    bA = blockRRs(blockRRs>mn & blockRRs<mx);
    bB = blockRRs(blockRRs<mn|blockRRs>mx);
    
    xPrev(trustStart) = exp(length(bA))/exp(length(sum(bB)));
    
    
    
end


res.rr_xd_min = min(xDiff);
res.rr_xd_max = max(xDiff);
res.rr_xd_std = std(xDiff);
res.rr_xd_mean = mean(xDiff);

res.rr_xm_min = min(xMom);
res.rr_xm_max = max(xMom);
res.rr_xm_std = std(xMom);
res.rr_xm_mean = mean(xMom);

res.rr_xp_min = min(xPrev);
res.rr_xp_max = max(xPrev);
res.rr_xp_std = std(xPrev);
res.rr_xp_mean = mean(xPrev);


[trustSTD trustStart] = min(stds);
trustEnd = trustStart+neededQRS;
trustLocs = majLocs(trustStart:trustEnd);
trustSTDs = stds; %vythnout i nejhor STD jako parametr; taky median std;

%%%%%%%%%
res.rr_tw_c0c_min = min(c0count);
res.rr_tw_c0c_max = max(c0count);
res.rr_tw_c0c_avg = mean(c0count);

res.rr_tw_c0a_min = min(c0avgRat);
res.rr_tw_c0a_max = max(c0avgRat);
res.rr_tw_c0a_avg = mean(c0avgRat);

res.rr_tw_c0s_min = min(c0avgStep);
res.rr_tw_c0s_max = max(c0avgStep);
res.rr_tw_c0s_med = median(c0avgStep);


res.twSequence = trustStart:trustEnd;
res.qrs_tw = majLocs(res.twSequence);
res.rr_tw =  diff(res.qrs_tw./fs);
res.rr_tw_std_min = trustSTD;
res.rr_tw_std_max = max(stds);
res.rr_tw_std_med = median(stds);
res.rr_tw_std_std = std(stds);

res.rr_tw_bpms_min = min(twbpms);
res.rr_tw_bpms_med = median(twbpms);
res.rr_tw_bpms_max = max(twbpms);
res.rr_tw_bpms_std = std(twbpms);

%%% fake jako hrom pro ppady, e to prost moc um a v majorGroup je
%%% mlo tep
trustGroups = computeGroupCounts(group(trustStart:trustEnd));

if length(res.twSequence)>1
    
    [tv ti] = max(trustGroups);
    so = sum(trustGroups(2:length(trustGroups)));
    
    res.qrs_1 = qrsTable(1,group==1);
    res.rr_1 = diff(res.qrs_1./fs);
    
    %so<tv
    if (ti==1 && so<tv) % || (trustSTD<0.05 && length(res.rr_1)<6)
        group(res.twSequence)=1;
        qrsTable(2,res.twSequence)=1;
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

res.qrsTable = qrsTable;
res.rr_all = diff(majLocs./fs);
res.qrs_all = majLocs;
res.qrs_1 = qrsTable(1,group==1); 
res.qrs_2 = qrsTable(1,group==2); 
%res.qrs_12 = qrsTable(1,group<3 && group>0); 
res.rr_1 = diff(res.qrs_1./fs);
res.rr_2 = diff(res.qrs_2./fs);
%res.rr_12 = diff(res.qrs_12./fs);

res.qrs_complete = qrsTable(1,group<3);
res.rr_complete = diff(res.qrs_complete./fs);

res.group = group;
res.groupCounts = computeGroupCounts(group); 

res.KESrisk = KESrisk;



if doPictures()*false

FigHandle = figure('Name','Detektor test');
set(FigHandle, 'Position', [100 400 2400 1000]);
 
  
handle = subplot(3,1,1);
     
hold on
plot(signalMF,'g');
plot(signalLF,'r');
plot(locs, signalMF(locs), 'bo');


handle = subplot(3,1,2);
hold on
plot (signalCF,'k');
plot(locs, signalCF(locs), 'bo')

%text(locs, signalCF(locs)+0.2,num2str(group));

text(locs(KESrisk>0), signalCF(locs(KESrisk>0))+0.2,num2str(KESrisk(KESrisk>0)));


for g=1:max(group)

red = min(1, 0.3+g/5);
green = max(0, 1-g/5);
    
color = [red green 0.5];
    
plot(locs(group==g), signalCF(locs(group==g)), 'ko','MarkerFaceColor',color);

%adl = addedLocations(g,:);

%adl(adl==0) = [];

%     if length(adl>0)
%     plot(adl, signalCF(adl), 'k*','MarkerFaceColor',[0.1 0.9 0.5])
%     end

end

plot(trustLocs,signalCF(trustLocs),'ko','LineWidth',2,'MarkerSize',14);

rrExRatioStarts = find(rrRatios>0);
rrExRatioMids = rrExRatioStarts+1;
rrExRatioEnds = rrExRatioStarts+2;

yv = ones(length(rrExRatioStarts),1).*max(signalCF);

if length(rrExRatioStarts>0)
    
xp =  [locs(rrExRatioStarts) locs(rrExRatioMids) locs(rrExRatioEnds)];   
yp = [yv' yv' yv'];
    
plot(xp,yp,'rx-','LineWidth',2,'MarkerSize',10);
end

handle = subplot(3,1,3);
hold on
rrs = diff(sort(locs(group==1)));
plot (rrs);

suffix = '_';

hgexport(FigHandle, [recordName,suffix,'.png'], hgexport('factorystyle'), 'Format', 'png');
   
if doTable()
close(FigHandle);

% 
end





end


