function result = validityTest(testedSignal, fs, winSizeSec, winStepSec, limitMin,limitMax,varrangeMin, varrangeMax, maxSTD)
%	Modified version of validity test submitted for CinC 2015 - version 208
%   Author F.Plesinger, 2015-2017


winSize = fix(winSizeSec*fs);
winStep = fix(winStepSec*fs);
invalidConnectSize=fix(1.5*winStepSec*fs);  % Pokud je posledn pedchoz invalid oblast bl, ne tato hodnota a objev se nov invalid, tak je mezera peklenuta invalid oblast



result = zeros(size(testedSignal));

lastInvalidPosition = -invalidConnectSize-1;

testStart=1;
maxData = length(testedSignal);

kTolerance = 0.1;
kBlockSize = 40;

%dataHF = hobalka(testedSignal,fs,45,fs/2);
%ratioHF = zeros(size(testedSignal));

for pos=testStart:winStep:maxData-winSize
    
    startIndex = pos;
    endIndex = pos+winSize;
    
    valid = 1; % 1= validn, zdrav signl; 0 = chybn, nevalidn signl
    
    block = testedSignal(startIndex:endIndex);
    
  %  hfBlock = dataHF(startIndex:endIndex);
    
    stdev = std (block);
    
    blockMin = min(block);
    blockMax = max(block);
    varrange = blockMax-blockMin;
    
    
  %  sumBlock = sum(abs(block));
  %  sumHF = sum(hfBlock);
    
  %  ratioHF(startIndex:endIndex) = sumHF;
    
    if (varrange==0) || isnan(varrange) 
        valid = 0; 
    end; 
    
     if (blockMin<limitMin) 
         valid = 0; 
     end;
     if (blockMax>limitMax) 
         valid = 0; 
     end;
    
     if (varrange<varrangeMin) 
         valid = 0;
     end;
     if (varrange>varrangeMax) 
         valid = 0;
     end;
     
     if (varrange>varrangeMax) 
         valid = 0;
     end;
     
     if stdev>maxSTD
         valid = 0;
     end;
    
%  vc navc ohledn zakmitn s velkou amplitudou
tL = blockMin + kTolerance*varrange;
tH = blockMin + (1-kTolerance)*varrange;

blockLeft = block(1:kBlockSize);
blockRight = block(winSize-kBlockSize:end);

%valid==1 v podmnkch ne je proto, aby se dal podmnky provdly jen tehdy, pokud
%je sample validn. V opanm ppad to nem smysl.

if (valid==1)&&((varrange>varrangeMax/10)&&(((min(blockRight)>tH)&&(max(blockLeft)<tL)) || ((min(blockLeft)>tH)&&(max(blockRight)<tL)))) %ochrana proti saturaci nahoe a dole
    valid = 0;
end

if (valid==1)&&((min(blockLeft)==max(blockLeft)) || (min(blockRight)==max(blockRight))) % ochrana proti zcela stejnm opakujcm se hodnotm
    valid = 0;
end
% 
% if (valid==1)&&(min(dataHF(pos:pos+winSize)>0.005))  %ochrana proti rychlm kmitm min/max 0.005 pvodn
%     valid=0;
% end

if (valid==1)&&((prctile(block,60)==blockMax)||(prctile(block,40)==blockMin)) %ochrana ped kmitnm signlu na dvou hodnotch - zhruba
    valid = 0;
end

%    konec kontroly zakmitn
   

% kontrola pomoc histogramu
if (true && valid==1)
nbins = 10;
histogram =hist(block, nbins);

sumLeft = sum(histogram(1));
sumRight = sum(histogram(10));
sumPerifery = sumLeft+sumRight;
sumCenter = sum(histogram(2:9));
kPer = 1;

valid = 1.0* sumCenter>sumPerifery || sumLeft<sumCenter*kPer || sumRight<sumCenter*kPer;

end
% konec kontroly pomoc histogramu


   if (valid==0)
            % jedn se o nevalidn oblast a musm ji vyplnit jednikama    
            result(startIndex:endIndex)= 1;
            
            lastInvalidDistance = pos-lastInvalidPosition;
            if lastInvalidDistance<invalidConnectSize
                result(lastInvalidPosition:pos)=1;
            end
            lastInvalidPosition=endIndex;
   end



end

end
